package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TCompany;
import com.haomostudio.so.service.TCompanyService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TCompany")
@Controller
public class TCompanyController {

    @Autowired
    TCompanyService tCompanyService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_companies/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "liablePerson", required = false) String liablePerson,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "workEmail", required = false) String workEmail,
            @RequestParam(value = "fixPhone", required = false) String fixPhone,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "inDate", required = false) String inDate,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createAdminUserId", required = false) Integer createAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updateAdminUserId", required = false) Integer updateAdminUserId
    ) {
        TCompany item = new TCompany();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( name != null ){
            item.setName(name);
        }
        if( code != null ){
            item.setCode(code);
        }
        if( professionCode != null ){
            item.setProfessionCode(professionCode);
        }
        if( professionName != null ){
            item.setProfessionName(professionName);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( companyScaleCode != null ){
            item.setCompanyScaleCode(companyScaleCode);
        }
        if( companyScaleName != null ){
            item.setCompanyScaleName(companyScaleName);
        }
        if( liablePerson != null ){
            item.setLiablePerson(liablePerson);
        }
        if( mobile != null ){
            item.setMobile(mobile);
        }
        if( workEmail != null ){
            item.setWorkEmail(workEmail);
        }
        if( fixPhone != null ){
            item.setFixPhone(fixPhone);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( inDate != null ){
            item.setInDate(Tools.convertStringToDate(inDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( expireDate != null ){
            item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createAdminUserId != null ){
            item.setCreateAdminUserId(createAdminUserId);
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updateAdminUserId != null ){
            item.setUpdateAdminUserId(updateAdminUserId);
        }
        tCompanyService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tCompanyService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TCompany'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_companies/{t_company_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTCompany(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_company_id") Integer id
    ) {
        TCompany item = tCompanyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tCompanyService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TCompany'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_companies/{t_company_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_company_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "liablePerson", required = false) String liablePerson,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "workEmail", required = false) String workEmail,
            @RequestParam(value = "fixPhone", required = false) String fixPhone,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "inDate", required = false) String inDate,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createAdminUserId", required = false) Integer createAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updateAdminUserId", required = false) Integer updateAdminUserId
    ) {
        TCompany item = tCompanyService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( name != null ){
            item.setName(name);
        }
        if( code != null ){
            item.setCode(code);
        }
        if( professionCode != null ){
            item.setProfessionCode(professionCode);
        }
        if( professionName != null ){
            item.setProfessionName(professionName);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( companyScaleCode != null ){
            item.setCompanyScaleCode(companyScaleCode);
        }
        if( companyScaleName != null ){
            item.setCompanyScaleName(companyScaleName);
        }
        if( liablePerson != null ){
            item.setLiablePerson(liablePerson);
        }
        if( mobile != null ){
            item.setMobile(mobile);
        }
        if( workEmail != null ){
            item.setWorkEmail(workEmail);
        }
        if( fixPhone != null ){
            item.setFixPhone(fixPhone);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( inDate != null ){
            item.setInDate(Tools.convertStringToDate(inDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( remark != null ){
            item.setRemark(remark);
        }
        if( expireDate != null ){
            item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( createAdminUserId != null ){
            item.setCreateAdminUserId(createAdminUserId);
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updateAdminUserId != null ){
            item.setUpdateAdminUserId(updateAdminUserId);
        }
        tCompanyService.update(item);

        return tCompanyService.get(id);
    }

    @ApiOperation(value = "查询'TCompany'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_companies/{t_company_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCompany(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_company_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "code", required = false) String code,
            @RequestParam(value = "professionCode", required = false) String professionCode,
            @RequestParam(value = "professionName", required = false) String professionName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "companyScaleCode", required = false) String companyScaleCode,
            @RequestParam(value = "companyScaleName", required = false) String companyScaleName,
            @RequestParam(value = "liablePerson", required = false) String liablePerson,
            @RequestParam(value = "mobile", required = false) String mobile,
            @RequestParam(value = "workEmail", required = false) String workEmail,
            @RequestParam(value = "fixPhone", required = false) String fixPhone,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "inDate", required = false) String inDate,
            @RequestParam(value = "remark", required = false) String remark,
            @RequestParam(value = "expireDate", required = false) String expireDate,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "createAdminUserId", required = false) Integer createAdminUserId,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "updateAdminUserId", required = false) Integer updateAdminUserId
    ) {
        if(request.getMethod().equals("GET")){
            TCompany item = tCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TCompany item = tCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( name != null ){
                item.setName(name);
            }
            if( code != null ){
                item.setCode(code);
            }
            if( professionCode != null ){
                item.setProfessionCode(professionCode);
            }
            if( professionName != null ){
                item.setProfessionName(professionName);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( companyScaleCode != null ){
                item.setCompanyScaleCode(companyScaleCode);
            }
            if( companyScaleName != null ){
                item.setCompanyScaleName(companyScaleName);
            }
            if( liablePerson != null ){
                item.setLiablePerson(liablePerson);
            }
            if( mobile != null ){
                item.setMobile(mobile);
            }
            if( workEmail != null ){
                item.setWorkEmail(workEmail);
            }
            if( fixPhone != null ){
                item.setFixPhone(fixPhone);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( inDate != null ){
                item.setInDate(Tools.convertStringToDate(inDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( remark != null ){
                item.setRemark(remark);
            }
            if( expireDate != null ){
                item.setExpireDate(Tools.convertStringToDate(expireDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( createAdminUserId != null ){
                item.setCreateAdminUserId(createAdminUserId);
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updateAdminUserId != null ){
                item.setUpdateAdminUserId(updateAdminUserId);
            }
            tCompanyService.update(item);

            return tCompanyService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TCompany item = tCompanyService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tCompanyService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TCompany'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_companies",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCompanies(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tCompanyService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tCompanyService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_companies/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTCompaniesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TCompany> list = tCompanyService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TCompany.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_companies/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTCompanies(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TCompany> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TCompany item = new TCompany();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("code")   ){
            item.setCode(jsonObject.get("code").toString());
        }
        if(jsonObject.containsKey("professionCode")   ){
            item.setProfessionCode(jsonObject.get("professionCode").toString());
        }
        if(jsonObject.containsKey("professionName")   ){
            item.setProfessionName(jsonObject.get("professionName").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("companyScaleCode")   ){
            item.setCompanyScaleCode(jsonObject.get("companyScaleCode").toString());
        }
        if(jsonObject.containsKey("companyScaleName")   ){
            item.setCompanyScaleName(jsonObject.get("companyScaleName").toString());
        }
        if(jsonObject.containsKey("liablePerson")   ){
            item.setLiablePerson(jsonObject.get("liablePerson").toString());
        }
        if(jsonObject.containsKey("mobile")   ){
            item.setMobile(jsonObject.get("mobile").toString());
        }
        if(jsonObject.containsKey("workEmail")   ){
            item.setWorkEmail(jsonObject.get("workEmail").toString());
        }
        if(jsonObject.containsKey("fixPhone")   ){
            item.setFixPhone(jsonObject.get("fixPhone").toString());
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("inDate")   ){
            item.setInDate(Tools.convertStringToDate(jsonObject.get("inDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("remark")   ){
            item.setRemark(jsonObject.get("remark").toString());
        }
        if(jsonObject.containsKey("expireDate")   ){
            item.setExpireDate(Tools.convertStringToDate(jsonObject.get("expireDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("createAdminUserId")   ){
            item.setCreateAdminUserId(Integer.valueOf(jsonObject.get("createAdminUserId").toString()));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updateAdminUserId")   ){
            item.setUpdateAdminUserId(Integer.valueOf(jsonObject.get("updateAdminUserId").toString()));
        }
             tCompanyService.create(item);
             lists.add(tCompanyService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TCompany'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_companies/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTCompany(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TCompany item = tCompanyService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tCompanyService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
