package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TLockBase;
import com.haomostudio.so.service.TLockBaseService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TLockBase")
@Controller
public class TLockBaseController {

    @Autowired
    TLockBaseService tLockBaseService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TLockBase'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_lock_bases/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTLockBase(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "lockName", required = false) String lockName,
            @RequestParam(value = "snId", required = false) String snId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "supplierId", required = false) String supplierId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "fieldType", required = false) Integer fieldType,
            @RequestParam(value = "fieldId", required = false) Integer fieldId,
            @RequestParam(value = "lockStatus", required = false) Integer lockStatus,
            @RequestParam(value = "isMain", required = false) Integer isMain,
            @RequestParam(value = "mainSnId", required = false) String mainSnId
    ) {
        TLockBase item = new TLockBase();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( lockName != null ){
            item.setLockName(lockName);
        }
        if( snId != null ){
            item.setSnId(snId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( supplierId != null ){
            item.setSupplierId(supplierId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( fieldType != null ){
            item.setFieldType(fieldType);
        }
        if( fieldId != null ){
            item.setFieldId(fieldId);
        }
        if( lockStatus != null ){
            item.setLockStatus(lockStatus);
        }
        if( isMain != null ){
            item.setIsMain(isMain);
        }
        if( mainSnId != null ){
            item.setMainSnId(mainSnId);
        }
        tLockBaseService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tLockBaseService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TLockBase'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_lock_bases/{t_lock_base_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTLockBase(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_base_id") Integer id
    ) {
        TLockBase item = tLockBaseService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tLockBaseService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TLockBase'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_lock_bases/{t_lock_base_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTLockBase(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_base_id") Integer id,
            @RequestParam(value = "lockName", required = false) String lockName,
            @RequestParam(value = "snId", required = false) String snId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "supplierId", required = false) String supplierId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "fieldType", required = false) Integer fieldType,
            @RequestParam(value = "fieldId", required = false) Integer fieldId,
            @RequestParam(value = "lockStatus", required = false) Integer lockStatus,
            @RequestParam(value = "isMain", required = false) Integer isMain,
            @RequestParam(value = "mainSnId", required = false) String mainSnId
    ) {
        TLockBase item = tLockBaseService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( lockName != null ){
            item.setLockName(lockName);
        }
        if( snId != null ){
            item.setSnId(snId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( supplierId != null ){
            item.setSupplierId(supplierId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( fieldType != null ){
            item.setFieldType(fieldType);
        }
        if( fieldId != null ){
            item.setFieldId(fieldId);
        }
        if( lockStatus != null ){
            item.setLockStatus(lockStatus);
        }
        if( isMain != null ){
            item.setIsMain(isMain);
        }
        if( mainSnId != null ){
            item.setMainSnId(mainSnId);
        }
        tLockBaseService.update(item);

        return tLockBaseService.get(id);
    }

    @ApiOperation(value = "查询'TLockBase'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_lock_bases/{t_lock_base_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockBase(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_base_id") Integer id,
            @RequestParam(value = "lockName", required = false) String lockName,
            @RequestParam(value = "snId", required = false) String snId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "supplierId", required = false) String supplierId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "fieldType", required = false) Integer fieldType,
            @RequestParam(value = "fieldId", required = false) Integer fieldId,
            @RequestParam(value = "lockStatus", required = false) Integer lockStatus,
            @RequestParam(value = "isMain", required = false) Integer isMain,
            @RequestParam(value = "mainSnId", required = false) String mainSnId
    ) {
        if(request.getMethod().equals("GET")){
            TLockBase item = tLockBaseService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TLockBase item = tLockBaseService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( lockName != null ){
                item.setLockName(lockName);
            }
            if( snId != null ){
                item.setSnId(snId);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( supplierId != null ){
                item.setSupplierId(supplierId);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( storeName != null ){
                item.setStoreName(storeName);
            }
            if( fieldType != null ){
                item.setFieldType(fieldType);
            }
            if( fieldId != null ){
                item.setFieldId(fieldId);
            }
            if( lockStatus != null ){
                item.setLockStatus(lockStatus);
            }
            if( isMain != null ){
                item.setIsMain(isMain);
            }
            if( mainSnId != null ){
                item.setMainSnId(mainSnId);
            }
            tLockBaseService.update(item);

            return tLockBaseService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TLockBase item = tLockBaseService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tLockBaseService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TLockBase'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_lock_bases",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockBases(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tLockBaseService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tLockBaseService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_lock_bases/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockBasesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TLockBase> list = tLockBaseService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TLockBase.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TLockBase'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_lock_bases/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTLockBases(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TLockBase> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TLockBase item = new TLockBase();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("lockName")   ){
            item.setLockName(jsonObject.get("lockName").toString());
        }
        if(jsonObject.containsKey("snId")   ){
            item.setSnId(jsonObject.get("snId").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("supplierId")   ){
            item.setSupplierId(jsonObject.get("supplierId").toString());
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("storeName")   ){
            item.setStoreName(jsonObject.get("storeName").toString());
        }
        if(jsonObject.containsKey("fieldType")   ){
            item.setFieldType(Integer.valueOf(jsonObject.get("fieldType").toString()));
        }
        if(jsonObject.containsKey("fieldId")   ){
            item.setFieldId(Integer.valueOf(jsonObject.get("fieldId").toString()));
        }
        if(jsonObject.containsKey("lockStatus")   ){
            item.setLockStatus(Integer.valueOf(jsonObject.get("lockStatus").toString()));
        }
        if(jsonObject.containsKey("isMain")   ){
            item.setIsMain(Integer.valueOf(jsonObject.get("isMain").toString()));
        }
        if(jsonObject.containsKey("mainSnId")   ){
            item.setMainSnId(jsonObject.get("mainSnId").toString());
        }
             tLockBaseService.create(item);
             lists.add(tLockBaseService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TLockBase'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_lock_bases/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTLockBase(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TLockBase item = tLockBaseService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tLockBaseService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
