package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TLockPstoneMaintain;
import com.haomostudio.so.service.TLockPstoneMaintainService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TLockPstoneMaintain")
@Controller
public class TLockPstoneMaintainController {

    @Autowired
    TLockPstoneMaintainService tLockPstoneMaintainService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TLockPstoneMaintain'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_lock_pstone_maintains/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTLockPstoneMaintain(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "userName", required = false) String userName,
            @RequestParam(value = "password", required = false) String password,
            @RequestParam(value = "lockBaseId", required = false) Integer lockBaseId,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "useTimeLimit", required = false) Integer useTimeLimit,
            @RequestParam(value = "useStartTime", required = false) String useStartTime,
            @RequestParam(value = "useEndTime", required = false) String useEndTime,
            @RequestParam(value = "source", required = false) Integer source,
            @RequestParam(value = "useStatus", required = false) Integer useStatus,
            @RequestParam(value = "createTime", required = false) String createTime,
            @RequestParam(value = "deleteTime", required = false) String deleteTime,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "passId", required = false) String passId,
            @RequestParam(value = "isDel", required = false) Integer isDel
    ) {
        TLockPstoneMaintain item = new TLockPstoneMaintain();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( userName != null ){
            item.setUserName(userName);
        }
        if( password != null ){
            item.setPassword(password);
        }
        if( lockBaseId != null ){
            item.setLockBaseId(lockBaseId);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( useTimeLimit != null ){
            item.setUseTimeLimit(useTimeLimit);
        }
        if( useStartTime != null ){
            item.setUseStartTime(Tools.convertStringToDate(useStartTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( useEndTime != null ){
            item.setUseEndTime(Tools.convertStringToDate(useEndTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( source != null ){
            item.setSource(source);
        }
        if( useStatus != null ){
            item.setUseStatus(useStatus);
        }
            item.setCreateTime(new Date());
        if( deleteTime != null ){
            item.setDeleteTime(Tools.convertStringToDate(deleteTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( passId != null ){
            item.setPassId(passId);
        }
        if( isDel != null ){
            item.setIsDel(isDel);
        }
        tLockPstoneMaintainService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tLockPstoneMaintainService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TLockPstoneMaintain'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_lock_pstone_maintains/{t_lock_pstone_maintain_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTLockPstoneMaintain(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_pstone_maintain_id") Integer id
    ) {
        TLockPstoneMaintain item = tLockPstoneMaintainService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tLockPstoneMaintainService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TLockPstoneMaintain'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_lock_pstone_maintains/{t_lock_pstone_maintain_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTLockPstoneMaintain(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_pstone_maintain_id") Integer id,
            @RequestParam(value = "userName", required = false) String userName,
            @RequestParam(value = "password", required = false) String password,
            @RequestParam(value = "lockBaseId", required = false) Integer lockBaseId,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "useTimeLimit", required = false) Integer useTimeLimit,
            @RequestParam(value = "useStartTime", required = false) String useStartTime,
            @RequestParam(value = "useEndTime", required = false) String useEndTime,
            @RequestParam(value = "source", required = false) Integer source,
            @RequestParam(value = "useStatus", required = false) Integer useStatus,
            @RequestParam(value = "deleteTime", required = false) String deleteTime,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "passId", required = false) String passId,
            @RequestParam(value = "isDel", required = false) Integer isDel
    ) {
        TLockPstoneMaintain item = tLockPstoneMaintainService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( userName != null ){
            item.setUserName(userName);
        }
        if( password != null ){
            item.setPassword(password);
        }
        if( lockBaseId != null ){
            item.setLockBaseId(lockBaseId);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( useTimeLimit != null ){
            item.setUseTimeLimit(useTimeLimit);
        }
        if( useStartTime != null ){
            item.setUseStartTime(Tools.convertStringToDate(useStartTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( useEndTime != null ){
            item.setUseEndTime(Tools.convertStringToDate(useEndTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( source != null ){
            item.setSource(source);
        }
        if( useStatus != null ){
            item.setUseStatus(useStatus);
        }
        if( deleteTime != null ){
            item.setDeleteTime(Tools.convertStringToDate(deleteTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( orderNum != null ){
            item.setOrderNum(orderNum);
        }
        if( passId != null ){
            item.setPassId(passId);
        }
        if( isDel != null ){
            item.setIsDel(isDel);
        }
        tLockPstoneMaintainService.update(item);

        return tLockPstoneMaintainService.get(id);
    }

    @ApiOperation(value = "查询'TLockPstoneMaintain'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_lock_pstone_maintains/{t_lock_pstone_maintain_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockPstoneMaintain(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_lock_pstone_maintain_id") Integer id,
            @RequestParam(value = "userName", required = false) String userName,
            @RequestParam(value = "password", required = false) String password,
            @RequestParam(value = "lockBaseId", required = false) Integer lockBaseId,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "useTimeLimit", required = false) Integer useTimeLimit,
            @RequestParam(value = "useStartTime", required = false) String useStartTime,
            @RequestParam(value = "useEndTime", required = false) String useEndTime,
            @RequestParam(value = "source", required = false) Integer source,
            @RequestParam(value = "useStatus", required = false) Integer useStatus,
            @RequestParam(value = "deleteTime", required = false) String deleteTime,
            @RequestParam(value = "orderNum", required = false) String orderNum,
            @RequestParam(value = "passId", required = false) String passId,
            @RequestParam(value = "isDel", required = false) Integer isDel
    ) {
        if(request.getMethod().equals("GET")){
            TLockPstoneMaintain item = tLockPstoneMaintainService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TLockPstoneMaintain item = tLockPstoneMaintainService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( userName != null ){
                item.setUserName(userName);
            }
            if( password != null ){
                item.setPassword(password);
            }
            if( lockBaseId != null ){
                item.setLockBaseId(lockBaseId);
            }
            if( userId != null ){
                item.setUserId(userId);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( useTimeLimit != null ){
                item.setUseTimeLimit(useTimeLimit);
            }
            if( useStartTime != null ){
                item.setUseStartTime(Tools.convertStringToDate(useStartTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( useEndTime != null ){
                item.setUseEndTime(Tools.convertStringToDate(useEndTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( source != null ){
                item.setSource(source);
            }
            if( useStatus != null ){
                item.setUseStatus(useStatus);
            }
            if( deleteTime != null ){
                item.setDeleteTime(Tools.convertStringToDate(deleteTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( orderNum != null ){
                item.setOrderNum(orderNum);
            }
            if( passId != null ){
                item.setPassId(passId);
            }
            if( isDel != null ){
                item.setIsDel(isDel);
            }
            tLockPstoneMaintainService.update(item);

            return tLockPstoneMaintainService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TLockPstoneMaintain item = tLockPstoneMaintainService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tLockPstoneMaintainService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TLockPstoneMaintain'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_lock_pstone_maintains",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockPstoneMaintains(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tLockPstoneMaintainService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tLockPstoneMaintainService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_lock_pstone_maintains/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTLockPstoneMaintainsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TLockPstoneMaintain> list = tLockPstoneMaintainService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TLockPstoneMaintain.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TLockPstoneMaintain'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_lock_pstone_maintains/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTLockPstoneMaintains(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TLockPstoneMaintain> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TLockPstoneMaintain item = new TLockPstoneMaintain();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("userName")   ){
            item.setUserName(jsonObject.get("userName").toString());
        }
        if(jsonObject.containsKey("password")   ){
            item.setPassword(jsonObject.get("password").toString());
        }
        if(jsonObject.containsKey("lockBaseId")   ){
            item.setLockBaseId(Integer.valueOf(jsonObject.get("lockBaseId").toString()));
        }
        if(jsonObject.containsKey("userId")   ){
            item.setUserId(Integer.valueOf(jsonObject.get("userId").toString()));
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("useTimeLimit")   ){
            item.setUseTimeLimit(Integer.valueOf(jsonObject.get("useTimeLimit").toString()));
        }
        if(jsonObject.containsKey("useStartTime")   ){
            item.setUseStartTime(Tools.convertStringToDate(jsonObject.get("useStartTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("useEndTime")   ){
            item.setUseEndTime(Tools.convertStringToDate(jsonObject.get("useEndTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("source")   ){
            item.setSource(Integer.valueOf(jsonObject.get("source").toString()));
        }
        if(jsonObject.containsKey("useStatus")   ){
            item.setUseStatus(Integer.valueOf(jsonObject.get("useStatus").toString()));
        }
            item.setCreateTime(new Date());
        if(jsonObject.containsKey("deleteTime")   ){
            item.setDeleteTime(Tools.convertStringToDate(jsonObject.get("deleteTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("orderNum")   ){
            item.setOrderNum(jsonObject.get("orderNum").toString());
        }
        if(jsonObject.containsKey("passId")   ){
            item.setPassId(jsonObject.get("passId").toString());
        }
        if(jsonObject.containsKey("isDel")   ){
            item.setIsDel(Integer.valueOf(jsonObject.get("isDel").toString()));
        }
             tLockPstoneMaintainService.create(item);
             lists.add(tLockPstoneMaintainService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TLockPstoneMaintain'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_lock_pstone_maintains/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTLockPstoneMaintain(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TLockPstoneMaintain item = tLockPstoneMaintainService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tLockPstoneMaintainService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
