package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TNetcaseInnovationTalentContest;
import com.haomostudio.so.service.TNetcaseInnovationTalentContestService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TNetcaseInnovationTalentContest")
@Controller
public class TNetcaseInnovationTalentContestController {

    @Autowired
    TNetcaseInnovationTalentContestService tNetcaseInnovationTalentContestService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TNetcaseInnovationTalentContest'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTNetcaseInnovationTalentContest(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "benefit", required = false) String benefit,
            @RequestParam(value = "domain", required = false) String domain,
            @RequestParam(value = "stage", required = false) String stage,
            @RequestParam(value = "establishedTime", required = false) String establishedTime,
            @RequestParam(value = "officePhone", required = false) String officePhone,
            @RequestParam(value = "employeeTotal", required = false) String employeeTotal,
            @RequestParam(value = "juniorTotal", required = false) String juniorTotal,
            @RequestParam(value = "technologyTotal", required = false) String technologyTotal,
            @RequestParam(value = "productKeyword", required = false) String productKeyword,
            @RequestParam(value = "principal", required = false) String principal,
            @RequestParam(value = "principalDuty", required = false) String principalDuty,
            @RequestParam(value = "certificateType", required = false) String certificateType,
            @RequestParam(value = "certificateNo", required = false) String certificateNo,
            @RequestParam(value = "highestDegree", required = false) String highestDegree,
            @RequestParam(value = "telephone", required = false) String telephone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "detail", required = false) String detail,
            @RequestParam(value = "source", required = false) String source,
            @RequestParam(value = "customerId", required = false) Integer customerId
    ) {
        TNetcaseInnovationTalentContest item = new TNetcaseInnovationTalentContest();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( name != null ){
            item.setName(name);
        }
        if( benefit != null ){
            item.setBenefit(benefit);
        }
        if( domain != null ){
            item.setDomain(domain);
        }
        if( stage != null ){
            item.setStage(stage);
        }
        if( establishedTime != null ){
            item.setEstablishedTime(establishedTime);
        }
        if( officePhone != null ){
            item.setOfficePhone(officePhone);
        }
        if( employeeTotal != null ){
            item.setEmployeeTotal(employeeTotal);
        }
        if( juniorTotal != null ){
            item.setJuniorTotal(juniorTotal);
        }
        if( technologyTotal != null ){
            item.setTechnologyTotal(technologyTotal);
        }
        if( productKeyword != null ){
            item.setProductKeyword(productKeyword);
        }
        if( principal != null ){
            item.setPrincipal(principal);
        }
        if( principalDuty != null ){
            item.setPrincipalDuty(principalDuty);
        }
        if( certificateType != null ){
            item.setCertificateType(certificateType);
        }
        if( certificateNo != null ){
            item.setCertificateNo(certificateNo);
        }
        if( highestDegree != null ){
            item.setHighestDegree(highestDegree);
        }
        if( telephone != null ){
            item.setTelephone(telephone);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( detail != null ){
            item.setDetail(detail);
        }
        if( source != null ){
            item.setSource(source);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        tNetcaseInnovationTalentContestService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tNetcaseInnovationTalentContestService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TNetcaseInnovationTalentContest'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/{t_netcase_innovation_talent_contest_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTNetcaseInnovationTalentContest(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_netcase_innovation_talent_contest_id") Integer id
    ) {
        TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tNetcaseInnovationTalentContestService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TNetcaseInnovationTalentContest'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/{t_netcase_innovation_talent_contest_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTNetcaseInnovationTalentContest(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_netcase_innovation_talent_contest_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "benefit", required = false) String benefit,
            @RequestParam(value = "domain", required = false) String domain,
            @RequestParam(value = "stage", required = false) String stage,
            @RequestParam(value = "establishedTime", required = false) String establishedTime,
            @RequestParam(value = "officePhone", required = false) String officePhone,
            @RequestParam(value = "employeeTotal", required = false) String employeeTotal,
            @RequestParam(value = "juniorTotal", required = false) String juniorTotal,
            @RequestParam(value = "technologyTotal", required = false) String technologyTotal,
            @RequestParam(value = "productKeyword", required = false) String productKeyword,
            @RequestParam(value = "principal", required = false) String principal,
            @RequestParam(value = "principalDuty", required = false) String principalDuty,
            @RequestParam(value = "certificateType", required = false) String certificateType,
            @RequestParam(value = "certificateNo", required = false) String certificateNo,
            @RequestParam(value = "highestDegree", required = false) String highestDegree,
            @RequestParam(value = "telephone", required = false) String telephone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "detail", required = false) String detail,
            @RequestParam(value = "source", required = false) String source,
            @RequestParam(value = "customerId", required = false) Integer customerId
    ) {
        TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( name != null ){
            item.setName(name);
        }
        if( benefit != null ){
            item.setBenefit(benefit);
        }
        if( domain != null ){
            item.setDomain(domain);
        }
        if( stage != null ){
            item.setStage(stage);
        }
        if( establishedTime != null ){
            item.setEstablishedTime(establishedTime);
        }
        if( officePhone != null ){
            item.setOfficePhone(officePhone);
        }
        if( employeeTotal != null ){
            item.setEmployeeTotal(employeeTotal);
        }
        if( juniorTotal != null ){
            item.setJuniorTotal(juniorTotal);
        }
        if( technologyTotal != null ){
            item.setTechnologyTotal(technologyTotal);
        }
        if( productKeyword != null ){
            item.setProductKeyword(productKeyword);
        }
        if( principal != null ){
            item.setPrincipal(principal);
        }
        if( principalDuty != null ){
            item.setPrincipalDuty(principalDuty);
        }
        if( certificateType != null ){
            item.setCertificateType(certificateType);
        }
        if( certificateNo != null ){
            item.setCertificateNo(certificateNo);
        }
        if( highestDegree != null ){
            item.setHighestDegree(highestDegree);
        }
        if( telephone != null ){
            item.setTelephone(telephone);
        }
        if( email != null ){
            item.setEmail(email);
        }
        if( detail != null ){
            item.setDetail(detail);
        }
        if( source != null ){
            item.setSource(source);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        tNetcaseInnovationTalentContestService.update(item);

        return tNetcaseInnovationTalentContestService.get(id);
    }

    @ApiOperation(value = "查询'TNetcaseInnovationTalentContest'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/{t_netcase_innovation_talent_contest_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTNetcaseInnovationTalentContest(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_netcase_innovation_talent_contest_id") Integer id,
            @RequestParam(value = "name", required = false) String name,
            @RequestParam(value = "benefit", required = false) String benefit,
            @RequestParam(value = "domain", required = false) String domain,
            @RequestParam(value = "stage", required = false) String stage,
            @RequestParam(value = "establishedTime", required = false) String establishedTime,
            @RequestParam(value = "officePhone", required = false) String officePhone,
            @RequestParam(value = "employeeTotal", required = false) String employeeTotal,
            @RequestParam(value = "juniorTotal", required = false) String juniorTotal,
            @RequestParam(value = "technologyTotal", required = false) String technologyTotal,
            @RequestParam(value = "productKeyword", required = false) String productKeyword,
            @RequestParam(value = "principal", required = false) String principal,
            @RequestParam(value = "principalDuty", required = false) String principalDuty,
            @RequestParam(value = "certificateType", required = false) String certificateType,
            @RequestParam(value = "certificateNo", required = false) String certificateNo,
            @RequestParam(value = "highestDegree", required = false) String highestDegree,
            @RequestParam(value = "telephone", required = false) String telephone,
            @RequestParam(value = "email", required = false) String email,
            @RequestParam(value = "detail", required = false) String detail,
            @RequestParam(value = "source", required = false) String source,
            @RequestParam(value = "customerId", required = false) Integer customerId
    ) {
        if(request.getMethod().equals("GET")){
            TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( name != null ){
                item.setName(name);
            }
            if( benefit != null ){
                item.setBenefit(benefit);
            }
            if( domain != null ){
                item.setDomain(domain);
            }
            if( stage != null ){
                item.setStage(stage);
            }
            if( establishedTime != null ){
                item.setEstablishedTime(establishedTime);
            }
            if( officePhone != null ){
                item.setOfficePhone(officePhone);
            }
            if( employeeTotal != null ){
                item.setEmployeeTotal(employeeTotal);
            }
            if( juniorTotal != null ){
                item.setJuniorTotal(juniorTotal);
            }
            if( technologyTotal != null ){
                item.setTechnologyTotal(technologyTotal);
            }
            if( productKeyword != null ){
                item.setProductKeyword(productKeyword);
            }
            if( principal != null ){
                item.setPrincipal(principal);
            }
            if( principalDuty != null ){
                item.setPrincipalDuty(principalDuty);
            }
            if( certificateType != null ){
                item.setCertificateType(certificateType);
            }
            if( certificateNo != null ){
                item.setCertificateNo(certificateNo);
            }
            if( highestDegree != null ){
                item.setHighestDegree(highestDegree);
            }
            if( telephone != null ){
                item.setTelephone(telephone);
            }
            if( email != null ){
                item.setEmail(email);
            }
            if( detail != null ){
                item.setDetail(detail);
            }
            if( source != null ){
                item.setSource(source);
            }
            if( customerId != null ){
                item.setCustomerId(customerId);
            }
            tNetcaseInnovationTalentContestService.update(item);

            return tNetcaseInnovationTalentContestService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tNetcaseInnovationTalentContestService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TNetcaseInnovationTalentContest'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTNetcaseInnovationTalentContests(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tNetcaseInnovationTalentContestService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tNetcaseInnovationTalentContestService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTNetcaseInnovationTalentContestsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TNetcaseInnovationTalentContest> list = tNetcaseInnovationTalentContestService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TNetcaseInnovationTalentContest.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TNetcaseInnovationTalentContest'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_netcase_innovation_talent_contests/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTNetcaseInnovationTalentContests(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TNetcaseInnovationTalentContest> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TNetcaseInnovationTalentContest item = new TNetcaseInnovationTalentContest();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("name")   ){
            item.setName(jsonObject.get("name").toString());
        }
        if(jsonObject.containsKey("benefit")   ){
            item.setBenefit(jsonObject.get("benefit").toString());
        }
        if(jsonObject.containsKey("domain")   ){
            item.setDomain(jsonObject.get("domain").toString());
        }
        if(jsonObject.containsKey("stage")   ){
            item.setStage(jsonObject.get("stage").toString());
        }
        if(jsonObject.containsKey("establishedTime")   ){
            item.setEstablishedTime(jsonObject.get("establishedTime").toString());
        }
        if(jsonObject.containsKey("officePhone")   ){
            item.setOfficePhone(jsonObject.get("officePhone").toString());
        }
        if(jsonObject.containsKey("employeeTotal")   ){
            item.setEmployeeTotal(jsonObject.get("employeeTotal").toString());
        }
        if(jsonObject.containsKey("juniorTotal")   ){
            item.setJuniorTotal(jsonObject.get("juniorTotal").toString());
        }
        if(jsonObject.containsKey("technologyTotal")   ){
            item.setTechnologyTotal(jsonObject.get("technologyTotal").toString());
        }
        if(jsonObject.containsKey("productKeyword")   ){
            item.setProductKeyword(jsonObject.get("productKeyword").toString());
        }
        if(jsonObject.containsKey("principal")   ){
            item.setPrincipal(jsonObject.get("principal").toString());
        }
        if(jsonObject.containsKey("principalDuty")   ){
            item.setPrincipalDuty(jsonObject.get("principalDuty").toString());
        }
        if(jsonObject.containsKey("certificateType")   ){
            item.setCertificateType(jsonObject.get("certificateType").toString());
        }
        if(jsonObject.containsKey("certificateNo")   ){
            item.setCertificateNo(jsonObject.get("certificateNo").toString());
        }
        if(jsonObject.containsKey("highestDegree")   ){
            item.setHighestDegree(jsonObject.get("highestDegree").toString());
        }
        if(jsonObject.containsKey("telephone")   ){
            item.setTelephone(jsonObject.get("telephone").toString());
        }
        if(jsonObject.containsKey("email")   ){
            item.setEmail(jsonObject.get("email").toString());
        }
        if(jsonObject.containsKey("detail")   ){
            item.setDetail(jsonObject.get("detail").toString());
        }
        if(jsonObject.containsKey("source")   ){
            item.setSource(jsonObject.get("source").toString());
        }
        if(jsonObject.containsKey("customerId")   ){
            item.setCustomerId(Integer.valueOf(jsonObject.get("customerId").toString()));
        }
             tNetcaseInnovationTalentContestService.create(item);
             lists.add(tNetcaseInnovationTalentContestService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TNetcaseInnovationTalentContest'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_netcase_innovation_talent_contests/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTNetcaseInnovationTalentContest(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TNetcaseInnovationTalentContest item = tNetcaseInnovationTalentContestService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tNetcaseInnovationTalentContestService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
