package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformActivityGiftCustomer;
import com.haomostudio.so.service.TPlatformActivityGiftCustomerService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformActivityGiftCustomer")
@Controller
public class TPlatformActivityGiftCustomerController {

    @Autowired
    TPlatformActivityGiftCustomerService tPlatformActivityGiftCustomerService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformActivityGiftCustomer'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_activity_gift_customers/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformActivityGiftCustomer(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformActivityId", required = false) Integer platformActivityId,
            @RequestParam(value = "giftType", required = false) Integer giftType,
            @RequestParam(value = "platformActivityGiftId", required = false) Integer platformActivityGiftId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "redpacketStatus", required = false) Integer redpacketStatus,
            @RequestParam(value = "redemptStartDate", required = false) String redemptStartDate,
            @RequestParam(value = "redemptEndDate", required = false) String redemptEndDate,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId
    ) {
        TPlatformActivityGiftCustomer item = new TPlatformActivityGiftCustomer();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( platformActivityId != null ){
            item.setPlatformActivityId(platformActivityId);
        }
        if( giftType != null ){
            item.setGiftType(giftType);
        }
        if( platformActivityGiftId != null ){
            item.setPlatformActivityGiftId(platformActivityGiftId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( redpacketStatus != null ){
            item.setRedpacketStatus(redpacketStatus);
        }
        if( redemptStartDate != null ){
            item.setRedemptStartDate(Tools.convertStringToDate(redemptStartDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( redemptEndDate != null ){
            item.setRedemptEndDate(Tools.convertStringToDate(redemptEndDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( platformCouponCustomerId != null ){
            item.setPlatformCouponCustomerId(platformCouponCustomerId);
        }
        tPlatformActivityGiftCustomerService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformActivityGiftCustomerService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformActivityGiftCustomer'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_activity_gift_customers/{t_platform_activity_gift_customer_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformActivityGiftCustomer(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_gift_customer_id") Integer id
    ) {
        TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformActivityGiftCustomerService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformActivityGiftCustomer'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_activity_gift_customers/{t_platform_activity_gift_customer_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformActivityGiftCustomer(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_gift_customer_id") Integer id,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformActivityId", required = false) Integer platformActivityId,
            @RequestParam(value = "giftType", required = false) Integer giftType,
            @RequestParam(value = "platformActivityGiftId", required = false) Integer platformActivityGiftId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "redpacketStatus", required = false) Integer redpacketStatus,
            @RequestParam(value = "redemptStartDate", required = false) String redemptStartDate,
            @RequestParam(value = "redemptEndDate", required = false) String redemptEndDate,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId
    ) {
        TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( platformActivityId != null ){
            item.setPlatformActivityId(platformActivityId);
        }
        if( giftType != null ){
            item.setGiftType(giftType);
        }
        if( platformActivityGiftId != null ){
            item.setPlatformActivityGiftId(platformActivityGiftId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( redpacketStatus != null ){
            item.setRedpacketStatus(redpacketStatus);
        }
        if( redemptStartDate != null ){
            item.setRedemptStartDate(Tools.convertStringToDate(redemptStartDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( redemptEndDate != null ){
            item.setRedemptEndDate(Tools.convertStringToDate(redemptEndDate, "yyyy-MM-dd HH:mm:ss"));
        }
        if( platformCouponCustomerId != null ){
            item.setPlatformCouponCustomerId(platformCouponCustomerId);
        }
        tPlatformActivityGiftCustomerService.update(item);

        return tPlatformActivityGiftCustomerService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformActivityGiftCustomer'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_activity_gift_customers/{t_platform_activity_gift_customer_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivityGiftCustomer(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_activity_gift_customer_id") Integer id,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformActivityId", required = false) Integer platformActivityId,
            @RequestParam(value = "giftType", required = false) Integer giftType,
            @RequestParam(value = "platformActivityGiftId", required = false) Integer platformActivityGiftId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "redpacketStatus", required = false) Integer redpacketStatus,
            @RequestParam(value = "redemptStartDate", required = false) String redemptStartDate,
            @RequestParam(value = "redemptEndDate", required = false) String redemptEndDate,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( customerId != null ){
                item.setCustomerId(customerId);
            }
            if( platformActivityId != null ){
                item.setPlatformActivityId(platformActivityId);
            }
            if( giftType != null ){
                item.setGiftType(giftType);
            }
            if( platformActivityGiftId != null ){
                item.setPlatformActivityGiftId(platformActivityGiftId);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( redpacketStatus != null ){
                item.setRedpacketStatus(redpacketStatus);
            }
            if( redemptStartDate != null ){
                item.setRedemptStartDate(Tools.convertStringToDate(redemptStartDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( redemptEndDate != null ){
                item.setRedemptEndDate(Tools.convertStringToDate(redemptEndDate, "yyyy-MM-dd HH:mm:ss"));
            }
            if( platformCouponCustomerId != null ){
                item.setPlatformCouponCustomerId(platformCouponCustomerId);
            }
            tPlatformActivityGiftCustomerService.update(item);

            return tPlatformActivityGiftCustomerService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformActivityGiftCustomerService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformActivityGiftCustomer'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_activity_gift_customers",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivityGiftCustomers(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformActivityGiftCustomerService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformActivityGiftCustomerService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_activity_gift_customers/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformActivityGiftCustomersId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformActivityGiftCustomer> list = tPlatformActivityGiftCustomerService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformActivityGiftCustomer.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformActivityGiftCustomer'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_activity_gift_customers/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformActivityGiftCustomers(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformActivityGiftCustomer> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformActivityGiftCustomer item = new TPlatformActivityGiftCustomer();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("customerId")   ){
            item.setCustomerId(Integer.valueOf(jsonObject.get("customerId").toString()));
        }
        if(jsonObject.containsKey("platformActivityId")   ){
            item.setPlatformActivityId(Integer.valueOf(jsonObject.get("platformActivityId").toString()));
        }
        if(jsonObject.containsKey("giftType")   ){
            item.setGiftType(Integer.valueOf(jsonObject.get("giftType").toString()));
        }
        if(jsonObject.containsKey("platformActivityGiftId")   ){
            item.setPlatformActivityGiftId(Integer.valueOf(jsonObject.get("platformActivityGiftId").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("redpacketStatus")   ){
            item.setRedpacketStatus(Integer.valueOf(jsonObject.get("redpacketStatus").toString()));
        }
        if(jsonObject.containsKey("redemptStartDate")   ){
            item.setRedemptStartDate(Tools.convertStringToDate(jsonObject.get("redemptStartDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("redemptEndDate")   ){
            item.setRedemptEndDate(Tools.convertStringToDate(jsonObject.get("redemptEndDate").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("platformCouponCustomerId")   ){
            item.setPlatformCouponCustomerId(Integer.valueOf(jsonObject.get("platformCouponCustomerId").toString()));
        }
             tPlatformActivityGiftCustomerService.create(item);
             lists.add(tPlatformActivityGiftCustomerService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformActivityGiftCustomer'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_activity_gift_customers/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformActivityGiftCustomer(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformActivityGiftCustomer item = tPlatformActivityGiftCustomerService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformActivityGiftCustomerService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
