package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformStatisticsField;
import com.haomostudio.so.service.TPlatformStatisticsFieldService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformStatisticsField")
@Controller
public class TPlatformStatisticsFieldController {

    @Autowired
    TPlatformStatisticsFieldService tPlatformStatisticsFieldService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformStatisticsField'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_statistics_fields/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformStatisticsField(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "relationDate", required = false) String relationDate,
            @RequestParam(value = "newSpaceCount", required = false) Integer newSpaceCount,
            @RequestParam(value = "newStoreCount", required = false) Integer newStoreCount,
            @RequestParam(value = "newFieldCount", required = false) Integer newFieldCount,
            @RequestParam(value = "meetingCount", required = false) Integer meetingCount,
            @RequestParam(value = "roadshowHallCount", required = false) Integer roadshowHallCount,
            @RequestParam(value = "stationCount", required = false) Integer stationCount,
            @RequestParam(value = "otherCount", required = false) Integer otherCount,
            @RequestParam(value = "officeCount", required = false) Integer officeCount,
            @RequestParam(value = "hourStationCount", required = false) Integer hourStationCount
    ) {
        TPlatformStatisticsField item = new TPlatformStatisticsField();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( relationDate != null ){
            item.setRelationDate(relationDate);
        }
        if( newSpaceCount != null ){
            item.setNewSpaceCount(newSpaceCount);
        }
        if( newStoreCount != null ){
            item.setNewStoreCount(newStoreCount);
        }
        if( newFieldCount != null ){
            item.setNewFieldCount(newFieldCount);
        }
        if( meetingCount != null ){
            item.setMeetingCount(meetingCount);
        }
        if( roadshowHallCount != null ){
            item.setRoadshowHallCount(roadshowHallCount);
        }
        if( stationCount != null ){
            item.setStationCount(stationCount);
        }
        if( otherCount != null ){
            item.setOtherCount(otherCount);
        }
        if( officeCount != null ){
            item.setOfficeCount(officeCount);
        }
        if( hourStationCount != null ){
            item.setHourStationCount(hourStationCount);
        }
        tPlatformStatisticsFieldService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformStatisticsFieldService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformStatisticsField'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_statistics_fields/{t_platform_statistics_field_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformStatisticsField(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_statistics_field_id") Integer id
    ) {
        TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformStatisticsFieldService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformStatisticsField'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_statistics_fields/{t_platform_statistics_field_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformStatisticsField(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_statistics_field_id") Integer id,
            @RequestParam(value = "relationDate", required = false) String relationDate,
            @RequestParam(value = "newSpaceCount", required = false) Integer newSpaceCount,
            @RequestParam(value = "newStoreCount", required = false) Integer newStoreCount,
            @RequestParam(value = "newFieldCount", required = false) Integer newFieldCount,
            @RequestParam(value = "meetingCount", required = false) Integer meetingCount,
            @RequestParam(value = "roadshowHallCount", required = false) Integer roadshowHallCount,
            @RequestParam(value = "stationCount", required = false) Integer stationCount,
            @RequestParam(value = "otherCount", required = false) Integer otherCount,
            @RequestParam(value = "officeCount", required = false) Integer officeCount,
            @RequestParam(value = "hourStationCount", required = false) Integer hourStationCount
    ) {
        TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( relationDate != null ){
            item.setRelationDate(relationDate);
        }
        if( newSpaceCount != null ){
            item.setNewSpaceCount(newSpaceCount);
        }
        if( newStoreCount != null ){
            item.setNewStoreCount(newStoreCount);
        }
        if( newFieldCount != null ){
            item.setNewFieldCount(newFieldCount);
        }
        if( meetingCount != null ){
            item.setMeetingCount(meetingCount);
        }
        if( roadshowHallCount != null ){
            item.setRoadshowHallCount(roadshowHallCount);
        }
        if( stationCount != null ){
            item.setStationCount(stationCount);
        }
        if( otherCount != null ){
            item.setOtherCount(otherCount);
        }
        if( officeCount != null ){
            item.setOfficeCount(officeCount);
        }
        if( hourStationCount != null ){
            item.setHourStationCount(hourStationCount);
        }
        tPlatformStatisticsFieldService.update(item);

        return tPlatformStatisticsFieldService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformStatisticsField'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_statistics_fields/{t_platform_statistics_field_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformStatisticsField(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_statistics_field_id") Integer id,
            @RequestParam(value = "relationDate", required = false) String relationDate,
            @RequestParam(value = "newSpaceCount", required = false) Integer newSpaceCount,
            @RequestParam(value = "newStoreCount", required = false) Integer newStoreCount,
            @RequestParam(value = "newFieldCount", required = false) Integer newFieldCount,
            @RequestParam(value = "meetingCount", required = false) Integer meetingCount,
            @RequestParam(value = "roadshowHallCount", required = false) Integer roadshowHallCount,
            @RequestParam(value = "stationCount", required = false) Integer stationCount,
            @RequestParam(value = "otherCount", required = false) Integer otherCount,
            @RequestParam(value = "officeCount", required = false) Integer officeCount,
            @RequestParam(value = "hourStationCount", required = false) Integer hourStationCount
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( relationDate != null ){
                item.setRelationDate(relationDate);
            }
            if( newSpaceCount != null ){
                item.setNewSpaceCount(newSpaceCount);
            }
            if( newStoreCount != null ){
                item.setNewStoreCount(newStoreCount);
            }
            if( newFieldCount != null ){
                item.setNewFieldCount(newFieldCount);
            }
            if( meetingCount != null ){
                item.setMeetingCount(meetingCount);
            }
            if( roadshowHallCount != null ){
                item.setRoadshowHallCount(roadshowHallCount);
            }
            if( stationCount != null ){
                item.setStationCount(stationCount);
            }
            if( otherCount != null ){
                item.setOtherCount(otherCount);
            }
            if( officeCount != null ){
                item.setOfficeCount(officeCount);
            }
            if( hourStationCount != null ){
                item.setHourStationCount(hourStationCount);
            }
            tPlatformStatisticsFieldService.update(item);

            return tPlatformStatisticsFieldService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformStatisticsFieldService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformStatisticsField'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_statistics_fields",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformStatisticsFields(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformStatisticsFieldService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformStatisticsFieldService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_statistics_fields/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformStatisticsFieldsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformStatisticsField> list = tPlatformStatisticsFieldService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformStatisticsField.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformStatisticsField'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_statistics_fields/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformStatisticsFields(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformStatisticsField> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformStatisticsField item = new TPlatformStatisticsField();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("relationDate")   ){
            item.setRelationDate(jsonObject.get("relationDate").toString());
        }
        if(jsonObject.containsKey("newSpaceCount")   ){
            item.setNewSpaceCount(Integer.valueOf(jsonObject.get("newSpaceCount").toString()));
        }
        if(jsonObject.containsKey("newStoreCount")   ){
            item.setNewStoreCount(Integer.valueOf(jsonObject.get("newStoreCount").toString()));
        }
        if(jsonObject.containsKey("newFieldCount")   ){
            item.setNewFieldCount(Integer.valueOf(jsonObject.get("newFieldCount").toString()));
        }
        if(jsonObject.containsKey("meetingCount")   ){
            item.setMeetingCount(Integer.valueOf(jsonObject.get("meetingCount").toString()));
        }
        if(jsonObject.containsKey("roadshowHallCount")   ){
            item.setRoadshowHallCount(Integer.valueOf(jsonObject.get("roadshowHallCount").toString()));
        }
        if(jsonObject.containsKey("stationCount")   ){
            item.setStationCount(Integer.valueOf(jsonObject.get("stationCount").toString()));
        }
        if(jsonObject.containsKey("otherCount")   ){
            item.setOtherCount(Integer.valueOf(jsonObject.get("otherCount").toString()));
        }
        if(jsonObject.containsKey("officeCount")   ){
            item.setOfficeCount(Integer.valueOf(jsonObject.get("officeCount").toString()));
        }
        if(jsonObject.containsKey("hourStationCount")   ){
            item.setHourStationCount(Integer.valueOf(jsonObject.get("hourStationCount").toString()));
        }
             tPlatformStatisticsFieldService.create(item);
             lists.add(tPlatformStatisticsFieldService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformStatisticsField'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_statistics_fields/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformStatisticsField(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformStatisticsField item = tPlatformStatisticsFieldService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformStatisticsFieldService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
