package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformVerifyRecord;
import com.haomostudio.so.service.TPlatformVerifyRecordService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformVerifyRecord")
@Controller
public class TPlatformVerifyRecordController {

    @Autowired
    TPlatformVerifyRecordService tPlatformVerifyRecordService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformVerifyRecord'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_records/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformVerifyRecord(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "tradeNum", required = false) String tradeNum,
            @RequestParam(value = "appCustomerId", required = false) Integer appCustomerId,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformCouponId", required = false) Integer platformCouponId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "platformVerifyStationId", required = false) Integer platformVerifyStationId,
            @RequestParam(value = "platformVerifierId", required = false) Integer platformVerifierId,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId,
            @RequestParam(value = "created", required = false) String created
    ) {
        TPlatformVerifyRecord item = new TPlatformVerifyRecord();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( tradeNum != null ){
            item.setTradeNum(tradeNum);
        }
        if( appCustomerId != null ){
            item.setAppCustomerId(appCustomerId);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( platformCouponId != null ){
            item.setPlatformCouponId(platformCouponId);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( platformVerifyStationId != null ){
            item.setPlatformVerifyStationId(platformVerifyStationId);
        }
        if( platformVerifierId != null ){
            item.setPlatformVerifierId(platformVerifierId);
        }
        if( platformCouponCustomerId != null ){
            item.setPlatformCouponCustomerId(platformCouponCustomerId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformVerifyRecordService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformVerifyRecordService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformVerifyRecord'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_verify_records/{t_platform_verify_record_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformVerifyRecord(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_record_id") Integer id
    ) {
        TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformVerifyRecordService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformVerifyRecord'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_records/{t_platform_verify_record_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformVerifyRecord(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_record_id") Integer id,
            @RequestParam(value = "tradeNum", required = false) String tradeNum,
            @RequestParam(value = "appCustomerId", required = false) Integer appCustomerId,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformCouponId", required = false) Integer platformCouponId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "platformVerifyStationId", required = false) Integer platformVerifyStationId,
            @RequestParam(value = "platformVerifierId", required = false) Integer platformVerifierId,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId,
            @RequestParam(value = "created", required = false) String created
    ) {
        TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( tradeNum != null ){
            item.setTradeNum(tradeNum);
        }
        if( appCustomerId != null ){
            item.setAppCustomerId(appCustomerId);
        }
        if( customerId != null ){
            item.setCustomerId(customerId);
        }
        if( platformCouponId != null ){
            item.setPlatformCouponId(platformCouponId);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( platformVerifyStationId != null ){
            item.setPlatformVerifyStationId(platformVerifyStationId);
        }
        if( platformVerifierId != null ){
            item.setPlatformVerifierId(platformVerifierId);
        }
        if( platformCouponCustomerId != null ){
            item.setPlatformCouponCustomerId(platformCouponCustomerId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformVerifyRecordService.update(item);

        return tPlatformVerifyRecordService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformVerifyRecord'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_verify_records/{t_platform_verify_record_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyRecord(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_verify_record_id") Integer id,
            @RequestParam(value = "tradeNum", required = false) String tradeNum,
            @RequestParam(value = "appCustomerId", required = false) Integer appCustomerId,
            @RequestParam(value = "customerId", required = false) Integer customerId,
            @RequestParam(value = "platformCouponId", required = false) Integer platformCouponId,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "platformVerifyStationId", required = false) Integer platformVerifyStationId,
            @RequestParam(value = "platformVerifierId", required = false) Integer platformVerifierId,
            @RequestParam(value = "platformCouponCustomerId", required = false) Integer platformCouponCustomerId,
            @RequestParam(value = "created", required = false) String created
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( tradeNum != null ){
                item.setTradeNum(tradeNum);
            }
            if( appCustomerId != null ){
                item.setAppCustomerId(appCustomerId);
            }
            if( customerId != null ){
                item.setCustomerId(customerId);
            }
            if( platformCouponId != null ){
                item.setPlatformCouponId(platformCouponId);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( platformVerifyStationId != null ){
                item.setPlatformVerifyStationId(platformVerifyStationId);
            }
            if( platformVerifierId != null ){
                item.setPlatformVerifierId(platformVerifierId);
            }
            if( platformCouponCustomerId != null ){
                item.setPlatformCouponCustomerId(platformCouponCustomerId);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            tPlatformVerifyRecordService.update(item);

            return tPlatformVerifyRecordService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformVerifyRecordService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformVerifyRecord'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_verify_records",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyRecords(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformVerifyRecordService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformVerifyRecordService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_verify_records/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformVerifyRecordsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformVerifyRecord> list = tPlatformVerifyRecordService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformVerifyRecord.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformVerifyRecord'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_verify_records/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformVerifyRecords(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformVerifyRecord> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformVerifyRecord item = new TPlatformVerifyRecord();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("tradeNum")   ){
            item.setTradeNum(jsonObject.get("tradeNum").toString());
        }
        if(jsonObject.containsKey("appCustomerId")   ){
            item.setAppCustomerId(Integer.valueOf(jsonObject.get("appCustomerId").toString()));
        }
        if(jsonObject.containsKey("customerId")   ){
            item.setCustomerId(Integer.valueOf(jsonObject.get("customerId").toString()));
        }
        if(jsonObject.containsKey("platformCouponId")   ){
            item.setPlatformCouponId(Integer.valueOf(jsonObject.get("platformCouponId").toString()));
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("platformVerifyStationId")   ){
            item.setPlatformVerifyStationId(Integer.valueOf(jsonObject.get("platformVerifyStationId").toString()));
        }
        if(jsonObject.containsKey("platformVerifierId")   ){
            item.setPlatformVerifierId(Integer.valueOf(jsonObject.get("platformVerifierId").toString()));
        }
        if(jsonObject.containsKey("platformCouponCustomerId")   ){
            item.setPlatformCouponCustomerId(Integer.valueOf(jsonObject.get("platformCouponCustomerId").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tPlatformVerifyRecordService.create(item);
             lists.add(tPlatformVerifyRecordService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformVerifyRecord'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_verify_records/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformVerifyRecord(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformVerifyRecord item = tPlatformVerifyRecordService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformVerifyRecordService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
