package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TPlatformWeixinPayUnifiedOrderReq;
import com.haomostudio.so.service.TPlatformWeixinPayUnifiedOrderReqService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TPlatformWeixinPayUnifiedOrderReq")
@Controller
public class TPlatformWeixinPayUnifiedOrderReqController {

    @Autowired
    TPlatformWeixinPayUnifiedOrderReqService tPlatformWeixinPayUnifiedOrderReqService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TPlatformWeixinPayUnifiedOrderReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTPlatformWeixinPayUnifiedOrderReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "body", required = false) String body,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "spbillCreateIp", required = false) String spbillCreateIp,
            @RequestParam(value = "goodsTag", required = false) String goodsTag,
            @RequestParam(value = "notifyUrl", required = false) String notifyUrl,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "productId", required = false) String productId,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "event", required = false) String event,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "relationNoId", required = false) Integer relationNoId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformWeixinPayUnifiedOrderReq item = new TPlatformWeixinPayUnifiedOrderReq();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( body != null ){
            item.setBody(body);
        }
        if( attach != null ){
            item.setAttach(attach);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( spbillCreateIp != null ){
            item.setSpbillCreateIp(spbillCreateIp);
        }
        if( goodsTag != null ){
            item.setGoodsTag(goodsTag);
        }
        if( notifyUrl != null ){
            item.setNotifyUrl(notifyUrl);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( productId != null ){
            item.setProductId(productId);
        }
        if( openId != null ){
            item.setOpenId(openId);
        }
        if( requestXml != null ){
            item.setRequestXml(requestXml);
        }
        if( event != null ){
            item.setEvent(event);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( relationNoId != null ){
            item.setRelationNoId(relationNoId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformWeixinPayUnifiedOrderReqService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tPlatformWeixinPayUnifiedOrderReqService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TPlatformWeixinPayUnifiedOrderReq'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/{t_platform_weixin_pay_unified_order_req_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTPlatformWeixinPayUnifiedOrderReq(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_req_id") Integer id
    ) {
        TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tPlatformWeixinPayUnifiedOrderReqService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TPlatformWeixinPayUnifiedOrderReq'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/{t_platform_weixin_pay_unified_order_req_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTPlatformWeixinPayUnifiedOrderReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_req_id") Integer id,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "body", required = false) String body,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "spbillCreateIp", required = false) String spbillCreateIp,
            @RequestParam(value = "goodsTag", required = false) String goodsTag,
            @RequestParam(value = "notifyUrl", required = false) String notifyUrl,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "productId", required = false) String productId,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "event", required = false) String event,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "relationNoId", required = false) Integer relationNoId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( body != null ){
            item.setBody(body);
        }
        if( attach != null ){
            item.setAttach(attach);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( spbillCreateIp != null ){
            item.setSpbillCreateIp(spbillCreateIp);
        }
        if( goodsTag != null ){
            item.setGoodsTag(goodsTag);
        }
        if( notifyUrl != null ){
            item.setNotifyUrl(notifyUrl);
        }
        if( tradeType != null ){
            item.setTradeType(tradeType);
        }
        if( productId != null ){
            item.setProductId(productId);
        }
        if( openId != null ){
            item.setOpenId(openId);
        }
        if( requestXml != null ){
            item.setRequestXml(requestXml);
        }
        if( event != null ){
            item.setEvent(event);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( relationNoId != null ){
            item.setRelationNoId(relationNoId);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        tPlatformWeixinPayUnifiedOrderReqService.update(item);

        return tPlatformWeixinPayUnifiedOrderReqService.get(id);
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayUnifiedOrderReq'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/{t_platform_weixin_pay_unified_order_req_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderReq(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_platform_weixin_pay_unified_order_req_id") Integer id,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "body", required = false) String body,
            @RequestParam(value = "attach", required = false) String attach,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "spbillCreateIp", required = false) String spbillCreateIp,
            @RequestParam(value = "goodsTag", required = false) String goodsTag,
            @RequestParam(value = "notifyUrl", required = false) String notifyUrl,
            @RequestParam(value = "tradeType", required = false) String tradeType,
            @RequestParam(value = "productId", required = false) String productId,
            @RequestParam(value = "openId", required = false) String openId,
            @RequestParam(value = "requestXml", required = false) String requestXml,
            @RequestParam(value = "event", required = false) String event,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "relationNoId", required = false) Integer relationNoId,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated
    ) {
        if(request.getMethod().equals("GET")){
            TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( appId != null ){
                item.setAppId(appId);
            }
            if( mchId != null ){
                item.setMchId(mchId);
            }
            if( body != null ){
                item.setBody(body);
            }
            if( attach != null ){
                item.setAttach(attach);
            }
            if( outTradeNo != null ){
                item.setOutTradeNo(outTradeNo);
            }
            if( totalFee != null ){
                item.setTotalFee(totalFee);
            }
            if( spbillCreateIp != null ){
                item.setSpbillCreateIp(spbillCreateIp);
            }
            if( goodsTag != null ){
                item.setGoodsTag(goodsTag);
            }
            if( notifyUrl != null ){
                item.setNotifyUrl(notifyUrl);
            }
            if( tradeType != null ){
                item.setTradeType(tradeType);
            }
            if( productId != null ){
                item.setProductId(productId);
            }
            if( openId != null ){
                item.setOpenId(openId);
            }
            if( requestXml != null ){
                item.setRequestXml(requestXml);
            }
            if( event != null ){
                item.setEvent(event);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( relationNoId != null ){
                item.setRelationNoId(relationNoId);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            tPlatformWeixinPayUnifiedOrderReqService.update(item);

            return tPlatformWeixinPayUnifiedOrderReqService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tPlatformWeixinPayUnifiedOrderReqService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TPlatformWeixinPayUnifiedOrderReq'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderReqs(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tPlatformWeixinPayUnifiedOrderReqService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tPlatformWeixinPayUnifiedOrderReqService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTPlatformWeixinPayUnifiedOrderReqsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TPlatformWeixinPayUnifiedOrderReq> list = tPlatformWeixinPayUnifiedOrderReqService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TPlatformWeixinPayUnifiedOrderReq.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TPlatformWeixinPayUnifiedOrderReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTPlatformWeixinPayUnifiedOrderReqs(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TPlatformWeixinPayUnifiedOrderReq> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TPlatformWeixinPayUnifiedOrderReq item = new TPlatformWeixinPayUnifiedOrderReq();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("appId")   ){
            item.setAppId(jsonObject.get("appId").toString());
        }
        if(jsonObject.containsKey("mchId")   ){
            item.setMchId(jsonObject.get("mchId").toString());
        }
        if(jsonObject.containsKey("body")   ){
            item.setBody(jsonObject.get("body").toString());
        }
        if(jsonObject.containsKey("attach")   ){
            item.setAttach(jsonObject.get("attach").toString());
        }
        if(jsonObject.containsKey("outTradeNo")   ){
            item.setOutTradeNo(jsonObject.get("outTradeNo").toString());
        }
        if(jsonObject.containsKey("totalFee")   ){
            item.setTotalFee(Integer.valueOf(jsonObject.get("totalFee").toString()));
        }
        if(jsonObject.containsKey("spbillCreateIp")   ){
            item.setSpbillCreateIp(jsonObject.get("spbillCreateIp").toString());
        }
        if(jsonObject.containsKey("goodsTag")   ){
            item.setGoodsTag(jsonObject.get("goodsTag").toString());
        }
        if(jsonObject.containsKey("notifyUrl")   ){
            item.setNotifyUrl(jsonObject.get("notifyUrl").toString());
        }
        if(jsonObject.containsKey("tradeType")   ){
            item.setTradeType(jsonObject.get("tradeType").toString());
        }
        if(jsonObject.containsKey("productId")   ){
            item.setProductId(jsonObject.get("productId").toString());
        }
        if(jsonObject.containsKey("openId")   ){
            item.setOpenId(jsonObject.get("openId").toString());
        }
        if(jsonObject.containsKey("requestXml")   ){
            item.setRequestXml(jsonObject.get("requestXml").toString());
        }
        if(jsonObject.containsKey("event")   ){
            item.setEvent(jsonObject.get("event").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("relationNoId")   ){
            item.setRelationNoId(Integer.valueOf(jsonObject.get("relationNoId").toString()));
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tPlatformWeixinPayUnifiedOrderReqService.create(item);
             lists.add(tPlatformWeixinPayUnifiedOrderReqService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TPlatformWeixinPayUnifiedOrderReq'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_platform_weixin_pay_unified_order_reqs/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTPlatformWeixinPayUnifiedOrderReq(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TPlatformWeixinPayUnifiedOrderReq item = tPlatformWeixinPayUnifiedOrderReqService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tPlatformWeixinPayUnifiedOrderReqService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
