package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TRegionInfo;
import com.haomostudio.so.service.TRegionInfoService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TRegionInfo")
@Controller
public class TRegionInfoController {

    @Autowired
    TRegionInfoService tRegionInfoService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TRegionInfo'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_region_infoes/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTRegionInfo(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "regionId", required = false) Integer regionId,
            @RequestParam(value = "regionCode", required = false) String regionCode,
            @RequestParam(value = "regionName", required = false) String regionName,
            @RequestParam(value = "engRegionName", required = false) String engRegionName,
            @RequestParam(value = "url", required = false) String url,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryCode", required = false) String countryCode,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "provinceId", required = false) Integer provinceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityId", required = false) Integer cityId,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "cityAliasName", required = false) String cityAliasName,
            @RequestParam(value = "sort", required = false) Integer sort
    ) {
        TRegionInfo item = new TRegionInfo();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( regionId != null ){
            item.setRegionId(regionId);
        }
        if( regionCode != null ){
            item.setRegionCode(regionCode);
        }
        if( regionName != null ){
            item.setRegionName(regionName);
        }
        if( engRegionName != null ){
            item.setEngRegionName(engRegionName);
        }
        if( url != null ){
            item.setUrl(url);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( longitude != null ){
            item.setLongitude(longitude);
        }
        if( latitude != null ){
            item.setLatitude(latitude);
        }
        if( countryId != null ){
            item.setCountryId(countryId);
        }
        if( countryCode != null ){
            item.setCountryCode(countryCode);
        }
        if( countryName != null ){
            item.setCountryName(countryName);
        }
        if( provinceId != null ){
            item.setProvinceId(provinceId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityId != null ){
            item.setCityId(cityId);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( cityAliasName != null ){
            item.setCityAliasName(cityAliasName);
        }
        if( sort != null ){
            item.setSort(sort);
        }
        tRegionInfoService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tRegionInfoService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TRegionInfo'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_region_infoes/{t_region_info_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTRegionInfo(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_region_info_id") Integer id
    ) {
        TRegionInfo item = tRegionInfoService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tRegionInfoService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TRegionInfo'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_region_infoes/{t_region_info_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTRegionInfo(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_region_info_id") Integer id,
            @RequestParam(value = "regionId", required = false) Integer regionId,
            @RequestParam(value = "regionCode", required = false) String regionCode,
            @RequestParam(value = "regionName", required = false) String regionName,
            @RequestParam(value = "engRegionName", required = false) String engRegionName,
            @RequestParam(value = "url", required = false) String url,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryCode", required = false) String countryCode,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "provinceId", required = false) Integer provinceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityId", required = false) Integer cityId,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "cityAliasName", required = false) String cityAliasName,
            @RequestParam(value = "sort", required = false) Integer sort
    ) {
        TRegionInfo item = tRegionInfoService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( regionId != null ){
            item.setRegionId(regionId);
        }
        if( regionCode != null ){
            item.setRegionCode(regionCode);
        }
        if( regionName != null ){
            item.setRegionName(regionName);
        }
        if( engRegionName != null ){
            item.setEngRegionName(engRegionName);
        }
        if( url != null ){
            item.setUrl(url);
        }
        if( created != null ){
            item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
        }
        if( updated != null ){
            item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
        }
        if( longitude != null ){
            item.setLongitude(longitude);
        }
        if( latitude != null ){
            item.setLatitude(latitude);
        }
        if( countryId != null ){
            item.setCountryId(countryId);
        }
        if( countryCode != null ){
            item.setCountryCode(countryCode);
        }
        if( countryName != null ){
            item.setCountryName(countryName);
        }
        if( provinceId != null ){
            item.setProvinceId(provinceId);
        }
        if( provinceCode != null ){
            item.setProvinceCode(provinceCode);
        }
        if( provinceName != null ){
            item.setProvinceName(provinceName);
        }
        if( cityId != null ){
            item.setCityId(cityId);
        }
        if( cityCode != null ){
            item.setCityCode(cityCode);
        }
        if( cityName != null ){
            item.setCityName(cityName);
        }
        if( status != null ){
            item.setStatus(status);
        }
        if( cityAliasName != null ){
            item.setCityAliasName(cityAliasName);
        }
        if( sort != null ){
            item.setSort(sort);
        }
        tRegionInfoService.update(item);

        return tRegionInfoService.get(id);
    }

    @ApiOperation(value = "查询'TRegionInfo'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_region_infoes/{t_region_info_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTRegionInfo(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_region_info_id") Integer id,
            @RequestParam(value = "regionId", required = false) Integer regionId,
            @RequestParam(value = "regionCode", required = false) String regionCode,
            @RequestParam(value = "regionName", required = false) String regionName,
            @RequestParam(value = "engRegionName", required = false) String engRegionName,
            @RequestParam(value = "url", required = false) String url,
            @RequestParam(value = "created", required = false) String created,
            @RequestParam(value = "updated", required = false) String updated,
            @RequestParam(value = "longitude", required = false) Double longitude,
            @RequestParam(value = "latitude", required = false) Double latitude,
            @RequestParam(value = "countryId", required = false) Integer countryId,
            @RequestParam(value = "countryCode", required = false) String countryCode,
            @RequestParam(value = "countryName", required = false) String countryName,
            @RequestParam(value = "provinceId", required = false) Integer provinceId,
            @RequestParam(value = "provinceCode", required = false) String provinceCode,
            @RequestParam(value = "provinceName", required = false) String provinceName,
            @RequestParam(value = "cityId", required = false) Integer cityId,
            @RequestParam(value = "cityCode", required = false) String cityCode,
            @RequestParam(value = "cityName", required = false) String cityName,
            @RequestParam(value = "status", required = false) Integer status,
            @RequestParam(value = "cityAliasName", required = false) String cityAliasName,
            @RequestParam(value = "sort", required = false) Integer sort
    ) {
        if(request.getMethod().equals("GET")){
            TRegionInfo item = tRegionInfoService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TRegionInfo item = tRegionInfoService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( regionId != null ){
                item.setRegionId(regionId);
            }
            if( regionCode != null ){
                item.setRegionCode(regionCode);
            }
            if( regionName != null ){
                item.setRegionName(regionName);
            }
            if( engRegionName != null ){
                item.setEngRegionName(engRegionName);
            }
            if( url != null ){
                item.setUrl(url);
            }
            if( created != null ){
                item.setCreated(Tools.convertStringToDate(created, "yyyy-MM-dd HH:mm:ss"));
            }
            if( updated != null ){
                item.setUpdated(Tools.convertStringToDate(updated, "yyyy-MM-dd HH:mm:ss"));
            }
            if( longitude != null ){
                item.setLongitude(longitude);
            }
            if( latitude != null ){
                item.setLatitude(latitude);
            }
            if( countryId != null ){
                item.setCountryId(countryId);
            }
            if( countryCode != null ){
                item.setCountryCode(countryCode);
            }
            if( countryName != null ){
                item.setCountryName(countryName);
            }
            if( provinceId != null ){
                item.setProvinceId(provinceId);
            }
            if( provinceCode != null ){
                item.setProvinceCode(provinceCode);
            }
            if( provinceName != null ){
                item.setProvinceName(provinceName);
            }
            if( cityId != null ){
                item.setCityId(cityId);
            }
            if( cityCode != null ){
                item.setCityCode(cityCode);
            }
            if( cityName != null ){
                item.setCityName(cityName);
            }
            if( status != null ){
                item.setStatus(status);
            }
            if( cityAliasName != null ){
                item.setCityAliasName(cityAliasName);
            }
            if( sort != null ){
                item.setSort(sort);
            }
            tRegionInfoService.update(item);

            return tRegionInfoService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TRegionInfo item = tRegionInfoService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tRegionInfoService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TRegionInfo'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_region_infoes",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTRegionInfoes(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tRegionInfoService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tRegionInfoService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_region_infoes/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTRegionInfoesId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TRegionInfo> list = tRegionInfoService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TRegionInfo.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TRegionInfo'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_region_infoes/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTRegionInfoes(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TRegionInfo> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TRegionInfo item = new TRegionInfo();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("regionId")   ){
            item.setRegionId(Integer.valueOf(jsonObject.get("regionId").toString()));
        }
        if(jsonObject.containsKey("regionCode")   ){
            item.setRegionCode(jsonObject.get("regionCode").toString());
        }
        if(jsonObject.containsKey("regionName")   ){
            item.setRegionName(jsonObject.get("regionName").toString());
        }
        if(jsonObject.containsKey("engRegionName")   ){
            item.setEngRegionName(jsonObject.get("engRegionName").toString());
        }
        if(jsonObject.containsKey("url")   ){
            item.setUrl(jsonObject.get("url").toString());
        }
        if(jsonObject.containsKey("created")   ){
            item.setCreated(Tools.convertStringToDate(jsonObject.get("created").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("updated")   ){
            item.setUpdated(Tools.convertStringToDate(jsonObject.get("updated").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("longitude")   ){
            item.setLongitude(new Double(jsonObject.get("longitude").toString()));
        }
        if(jsonObject.containsKey("latitude")   ){
            item.setLatitude(new Double(jsonObject.get("latitude").toString()));
        }
        if(jsonObject.containsKey("countryId")   ){
            item.setCountryId(Integer.valueOf(jsonObject.get("countryId").toString()));
        }
        if(jsonObject.containsKey("countryCode")   ){
            item.setCountryCode(jsonObject.get("countryCode").toString());
        }
        if(jsonObject.containsKey("countryName")   ){
            item.setCountryName(jsonObject.get("countryName").toString());
        }
        if(jsonObject.containsKey("provinceId")   ){
            item.setProvinceId(Integer.valueOf(jsonObject.get("provinceId").toString()));
        }
        if(jsonObject.containsKey("provinceCode")   ){
            item.setProvinceCode(jsonObject.get("provinceCode").toString());
        }
        if(jsonObject.containsKey("provinceName")   ){
            item.setProvinceName(jsonObject.get("provinceName").toString());
        }
        if(jsonObject.containsKey("cityId")   ){
            item.setCityId(Integer.valueOf(jsonObject.get("cityId").toString()));
        }
        if(jsonObject.containsKey("cityCode")   ){
            item.setCityCode(jsonObject.get("cityCode").toString());
        }
        if(jsonObject.containsKey("cityName")   ){
            item.setCityName(jsonObject.get("cityName").toString());
        }
        if(jsonObject.containsKey("status")   ){
            item.setStatus(Integer.valueOf(jsonObject.get("status").toString()));
        }
        if(jsonObject.containsKey("cityAliasName")   ){
            item.setCityAliasName(jsonObject.get("cityAliasName").toString());
        }
        if(jsonObject.containsKey("sort")   ){
            item.setSort(Integer.valueOf(jsonObject.get("sort").toString()));
        }
             tRegionInfoService.create(item);
             lists.add(tRegionInfoService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TRegionInfo'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_region_infoes/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTRegionInfo(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TRegionInfo item = tRegionInfoService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tRegionInfoService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
