package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TSpaceKeeperOrder;
import com.haomostudio.so.service.TSpaceKeeperOrderService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TSpaceKeeperOrder")
@Controller
public class TSpaceKeeperOrderController {

    @Autowired
    TSpaceKeeperOrderService tSpaceKeeperOrderService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TSpaceKeeperOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_orders/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTSpaceKeeperOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "orderNumber", required = false) String orderNumber,
            @RequestParam(value = "orderName", required = false) String orderName,
            @RequestParam(value = "orderDescription", required = false) String orderDescription,
            @RequestParam(value = "orderTypeId", required = false) Integer orderTypeId,
            @RequestParam(value = "orderTypeName", required = false) String orderTypeName,
            @RequestParam(value = "requireTime", required = false) String requireTime,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "imgUrl", required = false) String imgUrl,
            @RequestParam(value = "keeperId", required = false) Integer keeperId,
            @RequestParam(value = "keeperName", required = false) String keeperName,
            @RequestParam(value = "keeperPhone", required = false) String keeperPhone,
            @RequestParam(value = "createTime", required = false) String createTime,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "finishTime", required = false) String finishTime
    ) {
        TSpaceKeeperOrder item = new TSpaceKeeperOrder();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( orderNumber != null ){
            item.setOrderNumber(orderNumber);
        }
        if( orderName != null ){
            item.setOrderName(orderName);
        }
        if( orderDescription != null ){
            item.setOrderDescription(orderDescription);
        }
        if( orderTypeId != null ){
            item.setOrderTypeId(orderTypeId);
        }
        if( orderTypeName != null ){
            item.setOrderTypeName(orderTypeName);
        }
        if( requireTime != null ){
            item.setRequireTime(Tools.convertStringToDate(requireTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( companyId != null ){
            item.setCompanyId(companyId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( imgUrl != null ){
            item.setImgUrl(imgUrl);
        }
        if( keeperId != null ){
            item.setKeeperId(keeperId);
        }
        if( keeperName != null ){
            item.setKeeperName(keeperName);
        }
        if( keeperPhone != null ){
            item.setKeeperPhone(keeperPhone);
        }
            item.setCreateTime(new Date());
        if( modifiedTime != null ){
            item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( finishTime != null ){
            item.setFinishTime(Tools.convertStringToDate(finishTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tSpaceKeeperOrderService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tSpaceKeeperOrderService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TSpaceKeeperOrder'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_space_keeper_orders/{t_space_keeper_order_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTSpaceKeeperOrder(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_order_id") Integer id
    ) {
        TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tSpaceKeeperOrderService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TSpaceKeeperOrder'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_orders/{t_space_keeper_order_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTSpaceKeeperOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_order_id") Integer id,
            @RequestParam(value = "orderNumber", required = false) String orderNumber,
            @RequestParam(value = "orderName", required = false) String orderName,
            @RequestParam(value = "orderDescription", required = false) String orderDescription,
            @RequestParam(value = "orderTypeId", required = false) Integer orderTypeId,
            @RequestParam(value = "orderTypeName", required = false) String orderTypeName,
            @RequestParam(value = "requireTime", required = false) String requireTime,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "imgUrl", required = false) String imgUrl,
            @RequestParam(value = "keeperId", required = false) Integer keeperId,
            @RequestParam(value = "keeperName", required = false) String keeperName,
            @RequestParam(value = "keeperPhone", required = false) String keeperPhone,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "finishTime", required = false) String finishTime
    ) {
        TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( orderNumber != null ){
            item.setOrderNumber(orderNumber);
        }
        if( orderName != null ){
            item.setOrderName(orderName);
        }
        if( orderDescription != null ){
            item.setOrderDescription(orderDescription);
        }
        if( orderTypeId != null ){
            item.setOrderTypeId(orderTypeId);
        }
        if( orderTypeName != null ){
            item.setOrderTypeName(orderTypeName);
        }
        if( requireTime != null ){
            item.setRequireTime(Tools.convertStringToDate(requireTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( orderStatus != null ){
            item.setOrderStatus(orderStatus);
        }
        if( companyId != null ){
            item.setCompanyId(companyId);
        }
        if( companyName != null ){
            item.setCompanyName(companyName);
        }
        if( spaceId != null ){
            item.setSpaceId(spaceId);
        }
        if( storeId != null ){
            item.setStoreId(storeId);
        }
        if( storeName != null ){
            item.setStoreName(storeName);
        }
        if( userId != null ){
            item.setUserId(userId);
        }
        if( contact != null ){
            item.setContact(contact);
        }
        if( phone != null ){
            item.setPhone(phone);
        }
        if( imgUrl != null ){
            item.setImgUrl(imgUrl);
        }
        if( keeperId != null ){
            item.setKeeperId(keeperId);
        }
        if( keeperName != null ){
            item.setKeeperName(keeperName);
        }
        if( keeperPhone != null ){
            item.setKeeperPhone(keeperPhone);
        }
        if( modifiedTime != null ){
            item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( acceptTime != null ){
            item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
        }
        if( finishTime != null ){
            item.setFinishTime(Tools.convertStringToDate(finishTime, "yyyy-MM-dd HH:mm:ss"));
        }
        tSpaceKeeperOrderService.update(item);

        return tSpaceKeeperOrderService.get(id);
    }

    @ApiOperation(value = "查询'TSpaceKeeperOrder'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_space_keeper_orders/{t_space_keeper_order_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperOrder(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_space_keeper_order_id") Integer id,
            @RequestParam(value = "orderNumber", required = false) String orderNumber,
            @RequestParam(value = "orderName", required = false) String orderName,
            @RequestParam(value = "orderDescription", required = false) String orderDescription,
            @RequestParam(value = "orderTypeId", required = false) Integer orderTypeId,
            @RequestParam(value = "orderTypeName", required = false) String orderTypeName,
            @RequestParam(value = "requireTime", required = false) String requireTime,
            @RequestParam(value = "orderStatus", required = false) Integer orderStatus,
            @RequestParam(value = "companyId", required = false) Integer companyId,
            @RequestParam(value = "companyName", required = false) String companyName,
            @RequestParam(value = "spaceId", required = false) Integer spaceId,
            @RequestParam(value = "storeId", required = false) Integer storeId,
            @RequestParam(value = "storeName", required = false) String storeName,
            @RequestParam(value = "userId", required = false) Integer userId,
            @RequestParam(value = "contact", required = false) String contact,
            @RequestParam(value = "phone", required = false) String phone,
            @RequestParam(value = "imgUrl", required = false) String imgUrl,
            @RequestParam(value = "keeperId", required = false) Integer keeperId,
            @RequestParam(value = "keeperName", required = false) String keeperName,
            @RequestParam(value = "keeperPhone", required = false) String keeperPhone,
            @RequestParam(value = "modifiedTime", required = false) String modifiedTime,
            @RequestParam(value = "acceptTime", required = false) String acceptTime,
            @RequestParam(value = "finishTime", required = false) String finishTime
    ) {
        if(request.getMethod().equals("GET")){
            TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( orderNumber != null ){
                item.setOrderNumber(orderNumber);
            }
            if( orderName != null ){
                item.setOrderName(orderName);
            }
            if( orderDescription != null ){
                item.setOrderDescription(orderDescription);
            }
            if( orderTypeId != null ){
                item.setOrderTypeId(orderTypeId);
            }
            if( orderTypeName != null ){
                item.setOrderTypeName(orderTypeName);
            }
            if( requireTime != null ){
                item.setRequireTime(Tools.convertStringToDate(requireTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( orderStatus != null ){
                item.setOrderStatus(orderStatus);
            }
            if( companyId != null ){
                item.setCompanyId(companyId);
            }
            if( companyName != null ){
                item.setCompanyName(companyName);
            }
            if( spaceId != null ){
                item.setSpaceId(spaceId);
            }
            if( storeId != null ){
                item.setStoreId(storeId);
            }
            if( storeName != null ){
                item.setStoreName(storeName);
            }
            if( userId != null ){
                item.setUserId(userId);
            }
            if( contact != null ){
                item.setContact(contact);
            }
            if( phone != null ){
                item.setPhone(phone);
            }
            if( imgUrl != null ){
                item.setImgUrl(imgUrl);
            }
            if( keeperId != null ){
                item.setKeeperId(keeperId);
            }
            if( keeperName != null ){
                item.setKeeperName(keeperName);
            }
            if( keeperPhone != null ){
                item.setKeeperPhone(keeperPhone);
            }
            if( modifiedTime != null ){
                item.setModifiedTime(Tools.convertStringToDate(modifiedTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( acceptTime != null ){
                item.setAcceptTime(Tools.convertStringToDate(acceptTime, "yyyy-MM-dd HH:mm:ss"));
            }
            if( finishTime != null ){
                item.setFinishTime(Tools.convertStringToDate(finishTime, "yyyy-MM-dd HH:mm:ss"));
            }
            tSpaceKeeperOrderService.update(item);

            return tSpaceKeeperOrderService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tSpaceKeeperOrderService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TSpaceKeeperOrder'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_space_keeper_orders",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperOrders(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tSpaceKeeperOrderService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tSpaceKeeperOrderService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_space_keeper_orders/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTSpaceKeeperOrdersId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TSpaceKeeperOrder> list = tSpaceKeeperOrderService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TSpaceKeeperOrder.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TSpaceKeeperOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_space_keeper_orders/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTSpaceKeeperOrders(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TSpaceKeeperOrder> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TSpaceKeeperOrder item = new TSpaceKeeperOrder();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("orderNumber")   ){
            item.setOrderNumber(jsonObject.get("orderNumber").toString());
        }
        if(jsonObject.containsKey("orderName")   ){
            item.setOrderName(jsonObject.get("orderName").toString());
        }
        if(jsonObject.containsKey("orderDescription")   ){
            item.setOrderDescription(jsonObject.get("orderDescription").toString());
        }
        if(jsonObject.containsKey("orderTypeId")   ){
            item.setOrderTypeId(Integer.valueOf(jsonObject.get("orderTypeId").toString()));
        }
        if(jsonObject.containsKey("orderTypeName")   ){
            item.setOrderTypeName(jsonObject.get("orderTypeName").toString());
        }
        if(jsonObject.containsKey("requireTime")   ){
            item.setRequireTime(Tools.convertStringToDate(jsonObject.get("requireTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("orderStatus")   ){
            item.setOrderStatus(Integer.valueOf(jsonObject.get("orderStatus").toString()));
        }
        if(jsonObject.containsKey("companyId")   ){
            item.setCompanyId(Integer.valueOf(jsonObject.get("companyId").toString()));
        }
        if(jsonObject.containsKey("companyName")   ){
            item.setCompanyName(jsonObject.get("companyName").toString());
        }
        if(jsonObject.containsKey("spaceId")   ){
            item.setSpaceId(Integer.valueOf(jsonObject.get("spaceId").toString()));
        }
        if(jsonObject.containsKey("storeId")   ){
            item.setStoreId(Integer.valueOf(jsonObject.get("storeId").toString()));
        }
        if(jsonObject.containsKey("storeName")   ){
            item.setStoreName(jsonObject.get("storeName").toString());
        }
        if(jsonObject.containsKey("userId")   ){
            item.setUserId(Integer.valueOf(jsonObject.get("userId").toString()));
        }
        if(jsonObject.containsKey("contact")   ){
            item.setContact(jsonObject.get("contact").toString());
        }
        if(jsonObject.containsKey("phone")   ){
            item.setPhone(jsonObject.get("phone").toString());
        }
        if(jsonObject.containsKey("imgUrl")   ){
            item.setImgUrl(jsonObject.get("imgUrl").toString());
        }
        if(jsonObject.containsKey("keeperId")   ){
            item.setKeeperId(Integer.valueOf(jsonObject.get("keeperId").toString()));
        }
        if(jsonObject.containsKey("keeperName")   ){
            item.setKeeperName(jsonObject.get("keeperName").toString());
        }
        if(jsonObject.containsKey("keeperPhone")   ){
            item.setKeeperPhone(jsonObject.get("keeperPhone").toString());
        }
            item.setCreateTime(new Date());
        if(jsonObject.containsKey("modifiedTime")   ){
            item.setModifiedTime(Tools.convertStringToDate(jsonObject.get("modifiedTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("acceptTime")   ){
            item.setAcceptTime(Tools.convertStringToDate(jsonObject.get("acceptTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
        if(jsonObject.containsKey("finishTime")   ){
            item.setFinishTime(Tools.convertStringToDate(jsonObject.get("finishTime").toString(), "yyyy-MM-dd HH:mm:ss"));
        }
             tSpaceKeeperOrderService.create(item);
             lists.add(tSpaceKeeperOrderService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TSpaceKeeperOrder'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_space_keeper_orders/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTSpaceKeeperOrder(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TSpaceKeeperOrder item = tSpaceKeeperOrderService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tSpaceKeeperOrderService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
