package com.haomostudio.so.controller;

import com.haomostudio.so.common.Resp;
import com.haomostudio.so.po.TWeixinPayRefundResp;
import com.haomostudio.so.service.TWeixinPayRefundRespService;
import com.haomostudio.so.service.HmUtils.Tools;
import com.alibaba.fastjson.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by hxg on 2016/10/06.
 */
@Api(description = "TWeixinPayRefundResp")
@Controller
public class TWeixinPayRefundRespController {

    @Autowired
    TWeixinPayRefundRespService tWeixinPayRefundRespService;

    @Autowired
    HttpServletResponse response;

    @ApiOperation(value = "创建'TWeixinPayRefundResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/new",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createTWeixinPayRefundResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "returnMsg", required = false) String returnMsg,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "refundId", required = false) String refundId,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "responseXml", required = false) String responseXml,
            @RequestParam(value = "weixinPayRefundReqId", required = false) Integer weixinPayRefundReqId
    ) {
        TWeixinPayRefundResp item = new TWeixinPayRefundResp();
        String id = Tools.getUUID();
        item.setId(Integer.valueOf(id));
        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( returnMsg != null ){
            item.setReturnMsg(returnMsg);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( refundId != null ){
            item.setRefundId(refundId);
        }
        if( refundFee != null ){
            item.setRefundFee(refundFee);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( cashFee != null ){
            item.setCashFee(cashFee);
        }
        if( responseXml != null ){
            item.setResponseXml(responseXml);
        }
        if( weixinPayRefundReqId != null ){
            item.setWeixinPayRefundReqId(weixinPayRefundReqId);
        }
        tWeixinPayRefundRespService.create(item);

        //若request param为null，但字段定义有默认值，则需从数据库中返回结果
        return tWeixinPayRefundRespService.get(Integer.valueOf(id));
        //return item;
    }

    @ApiOperation(value = "删除'TWeixinPayRefundResp'表中的某条记录", notes = "根据url传入的数据id，删除整条记录。")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/{t_weixin_pay_refund_resp_id}/delete",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object deleteTWeixinPayRefundResp(
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_resp_id") Integer id
    ) {
        TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be deleted doesn't exist");
        }

        tWeixinPayRefundRespService.delete(id);
        return Resp.succ("delete success");
    }

    @ApiOperation(value = "修改'TWeixinPayRefundResp'表中的某条记录", notes = "根据url传入的数据id，确定修改表中的某条记录，传入表中字段要修改的信息，不传代表不修改。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/{t_weixin_pay_refund_resp_id}/edit",
                    method = RequestMethod.POST,
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object editTWeixinPayRefundResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_resp_id") Integer id,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "returnMsg", required = false) String returnMsg,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "refundId", required = false) String refundId,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "responseXml", required = false) String responseXml,
            @RequestParam(value = "weixinPayRefundReqId", required = false) Integer weixinPayRefundReqId
    ) {
        TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(id);
        if (null == item) {
            response.setStatus(404);
            return Resp.fail("the asset to be edited doesn't exist");
        }

        if( returnCode != null ){
            item.setReturnCode(returnCode);
        }
        if( returnMsg != null ){
            item.setReturnMsg(returnMsg);
        }
        if( resultCode != null ){
            item.setResultCode(resultCode);
        }
        if( appId != null ){
            item.setAppId(appId);
        }
        if( mchId != null ){
            item.setMchId(mchId);
        }
        if( transactionId != null ){
            item.setTransactionId(transactionId);
        }
        if( outTradeNo != null ){
            item.setOutTradeNo(outTradeNo);
        }
        if( refundId != null ){
            item.setRefundId(refundId);
        }
        if( refundFee != null ){
            item.setRefundFee(refundFee);
        }
        if( totalFee != null ){
            item.setTotalFee(totalFee);
        }
        if( cashFee != null ){
            item.setCashFee(cashFee);
        }
        if( responseXml != null ){
            item.setResponseXml(responseXml);
        }
        if( weixinPayRefundReqId != null ){
            item.setWeixinPayRefundReqId(weixinPayRefundReqId);
        }
        tWeixinPayRefundRespService.update(item);

        return tWeixinPayRefundRespService.get(id);
    }

    @ApiOperation(value = "查询'TWeixinPayRefundResp'表中的某条记录", notes = "根据url传入的数据id，查询对应的一条数据。")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/{t_weixin_pay_refund_resp_id}",
                    method = {RequestMethod.GET, RequestMethod.DELETE, RequestMethod.PUT},
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundResp(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token") String token,
            @PathVariable(value = "t_weixin_pay_refund_resp_id") Integer id,
            @RequestParam(value = "returnCode", required = false) String returnCode,
            @RequestParam(value = "returnMsg", required = false) String returnMsg,
            @RequestParam(value = "resultCode", required = false) String resultCode,
            @RequestParam(value = "appId", required = false) String appId,
            @RequestParam(value = "mchId", required = false) String mchId,
            @RequestParam(value = "transactionId", required = false) String transactionId,
            @RequestParam(value = "outTradeNo", required = false) String outTradeNo,
            @RequestParam(value = "refundId", required = false) String refundId,
            @RequestParam(value = "refundFee", required = false) Integer refundFee,
            @RequestParam(value = "totalFee", required = false) Integer totalFee,
            @RequestParam(value = "cashFee", required = false) Integer cashFee,
            @RequestParam(value = "responseXml", required = false) String responseXml,
            @RequestParam(value = "weixinPayRefundReqId", required = false) Integer weixinPayRefundReqId
    ) {
        if(request.getMethod().equals("GET")){
            TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            return item;
        }
        else if(request.getMethod().equals("PUT")){
            TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be edited doesn't exist");
            }

            if( returnCode != null ){
                item.setReturnCode(returnCode);
            }
            if( returnMsg != null ){
                item.setReturnMsg(returnMsg);
            }
            if( resultCode != null ){
                item.setResultCode(resultCode);
            }
            if( appId != null ){
                item.setAppId(appId);
            }
            if( mchId != null ){
                item.setMchId(mchId);
            }
            if( transactionId != null ){
                item.setTransactionId(transactionId);
            }
            if( outTradeNo != null ){
                item.setOutTradeNo(outTradeNo);
            }
            if( refundId != null ){
                item.setRefundId(refundId);
            }
            if( refundFee != null ){
                item.setRefundFee(refundFee);
            }
            if( totalFee != null ){
                item.setTotalFee(totalFee);
            }
            if( cashFee != null ){
                item.setCashFee(cashFee);
            }
            if( responseXml != null ){
                item.setResponseXml(responseXml);
            }
            if( weixinPayRefundReqId != null ){
                item.setWeixinPayRefundReqId(weixinPayRefundReqId);
            }
            tWeixinPayRefundRespService.update(item);

            return tWeixinPayRefundRespService.get(id);
        }
        else if(request.getMethod().equals("DELETE")){
            TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(id);
            if (null == item) {
                response.setStatus(404);
                return Resp.fail("the asset to be deleted doesn't exist");
            }

            tWeixinPayRefundRespService.delete(id);
            return Resp.succ("delete success");
        }
        return Resp.fail("Unknown http method");
    }

    @ApiOperation(value = "查询'TWeixinPayRefundResp'表中的多条记录或者新增某条记录", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。数据数量取决于pageNo和pageSize；数据的先后顺序取决于sortItem，sortOrder；   post请求：新增某条记录，传入表字段对应的值")
    @RequestMapping(value = "/t_weixin_pay_refund_resps",
                    method = { RequestMethod.GET, RequestMethod.POST },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundResps(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "includes", required = false) String includes,
            @RequestParam(value = "refers", required = false) String refers,
            @RequestParam(value = "relates", required = false) String relates
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortItem == null){
            sortItem = "id";
        }
        if(sortOrder == null){
            sortOrder = "asc";
        }
        if(filters == null){
            filters = "{}";
        }

        Long total = tWeixinPayRefundRespService.countListWithPagingAndFilter(filters);
        response.addHeader("total", String.valueOf(total));

        return tWeixinPayRefundRespService.getListWithPagingAndFilter(
                        pageNo, pageSize, sortItem, sortOrder, filters, includes, refers, relates);

    }

    @ApiOperation(value = "出入字段数组返回对应字段数据", notes = "get传参：根据url传入的filters（过滤条件），查询对应的多条数据。只返回你传进来的字段对应的数据")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/columns",
                    method = { RequestMethod.GET },
                    produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object getTWeixinPayRefundRespsId(
            HttpServletRequest request,
            @RequestHeader(value = "X-Auth-Token", required = false) String token,
            @RequestParam(value = "filters", required = true) String filters,
            @RequestParam(value = "columns", required = true) String columns,
            @RequestParam(value = "sortOrder", required = false) String sortOrder,
            @RequestParam(value = "sortItem", required = false) String sortItem,
            @RequestParam(value = "pageNo", required = false) Integer pageNo,
            @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {
        if(pageNo == null){
            pageNo = 1;
        }
        if(pageSize == null){
            pageSize = 10;
        }
        if(sortOrder==null){
            sortOrder = "asc";
        }
        if(sortItem==null){
            sortItem = "id";
        }
        JSONArray jsonArray = JSON.parseArray(columns);
        List<Map<String,Object>> lists  = new ArrayList<>();
        List<TWeixinPayRefundResp> list = tWeixinPayRefundRespService.getListWithPagingAndFilter(
                pageNo, pageSize, sortItem, sortOrder, filters);

        //反射调取get方法
        Class clz = TWeixinPayRefundResp.class;
        list.stream().forEach(lot->{
            Map<String,Object> map = new HashMap<>();
            for (Object j : jsonArray){
                String s = (String) j;
                s = s.replaceFirst(s.substring(0,1),s.substring(0,1).toUpperCase());
                try {
                    if (clz.getMethod("get"+s).invoke(lot) !=null){
                        map.put((String) j,clz.getMethod("get"+s).invoke(lot));
                    }
                } catch (NoSuchMethodException e) {
                    e.printStackTrace();
                } catch (InvocationTargetException e) {
                    e.printStackTrace();
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
            lists.add(map);
        });

        return lists;
     }



    @ApiOperation(value = "批量创建'TWeixinPayRefundResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
    @RequestMapping(value = "/t_weixin_pay_refund_resps/create//batch",
               method = RequestMethod.POST,
               produces = "application/json;charset=UTF-8")
    @ResponseBody
    public Object createsTWeixinPayRefundResps(
             HttpServletRequest request,
             @RequestHeader(value = "X-Auth-Token", required = false) String token,
             @RequestParam(value = "params", required = false) String params
    ) {

             JSONArray jsonArray = JSON.parseArray(params);
             List<TWeixinPayRefundResp> lists  = new ArrayList<>();

             jsonArray.stream().forEach((Object object) -> {

             JSONObject jsonObject = JSONObject.parseObject(object.toString());

             TWeixinPayRefundResp item = new TWeixinPayRefundResp();
             String id = Tools.getUUID();
                         item.setId(Integer.valueOf(id));
             if(jsonObject.containsKey("returnCode")   ){
            item.setReturnCode(jsonObject.get("returnCode").toString());
        }
        if(jsonObject.containsKey("returnMsg")   ){
            item.setReturnMsg(jsonObject.get("returnMsg").toString());
        }
        if(jsonObject.containsKey("resultCode")   ){
            item.setResultCode(jsonObject.get("resultCode").toString());
        }
        if(jsonObject.containsKey("appId")   ){
            item.setAppId(jsonObject.get("appId").toString());
        }
        if(jsonObject.containsKey("mchId")   ){
            item.setMchId(jsonObject.get("mchId").toString());
        }
        if(jsonObject.containsKey("transactionId")   ){
            item.setTransactionId(jsonObject.get("transactionId").toString());
        }
        if(jsonObject.containsKey("outTradeNo")   ){
            item.setOutTradeNo(jsonObject.get("outTradeNo").toString());
        }
        if(jsonObject.containsKey("refundId")   ){
            item.setRefundId(jsonObject.get("refundId").toString());
        }
        if(jsonObject.containsKey("refundFee")   ){
            item.setRefundFee(Integer.valueOf(jsonObject.get("refundFee").toString()));
        }
        if(jsonObject.containsKey("totalFee")   ){
            item.setTotalFee(Integer.valueOf(jsonObject.get("totalFee").toString()));
        }
        if(jsonObject.containsKey("cashFee")   ){
            item.setCashFee(Integer.valueOf(jsonObject.get("cashFee").toString()));
        }
        if(jsonObject.containsKey("responseXml")   ){
            item.setResponseXml(jsonObject.get("responseXml").toString());
        }
        if(jsonObject.containsKey("weixinPayRefundReqId")   ){
            item.setWeixinPayRefundReqId(Integer.valueOf(jsonObject.get("weixinPayRefundReqId").toString()));
        }
             tWeixinPayRefundRespService.create(item);
             lists.add(tWeixinPayRefundRespService.get(Integer.valueOf(id)));

             });
        return lists;
     }

    @ApiOperation(value = "批量删除'TWeixinPayRefundResp'表中一条信息", notes = "通过post方法请求，传入表中字段的对应信息，创建一条数据。并返回给View层")
        @RequestMapping(value = "/t_weixin_pay_refund_resps/delete/batch",
                method = RequestMethod.POST,
                produces = "application/json;charset=UTF-8")
        @ResponseBody
        public Object deletesTWeixinPayRefundResp(
                HttpServletRequest request,
                @RequestHeader(value = "X-Auth-Token", required = false) String token,
                @RequestParam(value = "ids", required = true) String ids
        ) {

            JSONArray jsonArray = JSON.parseArray(ids);
            jsonArray.stream().forEach(id->{

                 TWeixinPayRefundResp item = tWeixinPayRefundRespService.get(Integer.valueOf(id.toString()));
                if (null != item) {
                    tWeixinPayRefundRespService.delete(Integer.valueOf(id.toString()));
                }

            });
            return Resp.succ("delete success");
        }
}
