package com.haomostudio.so.utils;


import com.alibaba.fastjson.JSONObject;
import com.sun.jersey.core.util.Base64;
import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.httpclient.methods.InputStreamRequestEntity;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.HttpClient;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.io.*;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Date;
import java.util.UUID;

/**
 * 共通工具类
 *
 * @author wu
 */
public class CommonUtil {

    private static final String HMAC_SHA1 = "HmacSHA256";

    /**
     * Éú³ÉUUID
     *
     * @return
     */
    public static String getUUID() {
        UUID uuid = UUID.randomUUID();
        String str = uuid.toString();
        String uuidStr = str.replace("-", "");
        return uuidStr;
    }

    public static String sha1(String content, String key) throws NoSuchAlgorithmException,
            InvalidKeyException {

        SecretKeySpec signingKey = new SecretKeySpec(key.getBytes(), HMAC_SHA1);
        Mac mac = Mac.getInstance(HMAC_SHA1);
        mac.init(signingKey);
        mac.doFinal(content.getBytes());
        return new String(Base64.encode(mac.doFinal(content.getBytes())));

    }


    public static String getSignature(String params, String date,String url) {

        int i = (int) ((Math.random() * 9 + 1) * 100000);

        String HTTP_METHOD = "POST";
        String body = DigestUtils.md5Hex(params);
        String CanonicalizedResource = url;
        String key = "83366263-d239-474f-b668-9412af2c800a";

        String content = null;
        try {
            content = new String(Base64.encode(sha1(HTTP_METHOD + body + date + CanonicalizedResource, key)));
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        } catch (InvalidKeyException e) {
            e.printStackTrace();
        }
        String Signature = "NK dairy:" + content + "(" + i + ")";

        System.out.println(Signature);

        return Signature;
    }

    public static String sendPost(String params, String requestUrl,
                                  String Signature, String date) throws IOException {

        byte[] requestBytes = params.getBytes("utf-8"); // 将参数转为二进制流
        HttpClient httpClient = new HttpClient();// 客户端实例化
        PostMethod postMethod = new PostMethod(requestUrl);
        //设置请求头Authorization
        postMethod.setRequestHeader("Date", date);
        // 设置请求头  Content-Type
        postMethod.setRequestHeader("Signature", Signature);
        postMethod.setRequestHeader("Content-Type", "application/json");
        InputStream inputStream = new ByteArrayInputStream(requestBytes, 0,
                requestBytes.length);
        RequestEntity requestEntity = new InputStreamRequestEntity(inputStream,
                requestBytes.length, "application/json; charset=utf-8"); // 请求体
        postMethod.setRequestEntity(requestEntity);
        httpClient.executeMethod(postMethod);// 执行请求
        InputStream soapResponseStream = postMethod.getResponseBodyAsStream();// 获取返回的流
        byte[] datas = null;
        try {
            datas = readInputStream(soapResponseStream);// 从输入流中读取数据
        } catch (Exception e) {
            e.printStackTrace();
        }
        String result = new String(datas, "UTF-8");// 将二进制流转为String
        // 打印返回结果
        System.out.println(result);

        return result;

    }

    /**
     * 从输入流中读取数据
     *
     * @param inStream
     * @return
     * @throws Exception
     */
    public static byte[] readInputStream(InputStream inStream) throws Exception {
        ByteArrayOutputStream outStream = new ByteArrayOutputStream();
        byte[] buffer = new byte[1024];
        int len = 0;
        while ((len = inStream.read(buffer)) != -1) {
            outStream.write(buffer, 0, len);
        }
        byte[] data = outStream.toByteArray();
        outStream.close();
        inStream.close();
        return data;
    }


    public static void main(String[] args) throws NoSuchAlgorithmException, UnsupportedEncodingException, InvalidKeyException {

        String date = new Date().toString();

        JSONObject param = new JSONObject();
        param.put("access_token", "dairy");

        String params = param.toString();
        String url = "/third/uuas/api/oauth/removeToken";



        String signature = getSignature(params, date,url);

        try {
            String s1 = sendPost(params, "http://111.203.21.91/zuul/third/uuas/api/oauth/removeToken", signature, date);

        } catch (IOException e) {
            e.printStackTrace();
        }


    }


}
